#!/usr/bin/env node
"use strict";
// ------------------------------------------------------------------------
// Copyright (c) 2018-2024 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License.
// ------------------------------------------------------------------------

Object.defineProperty(exports,"__esModule",{value:!0});var Cli,sysFs=require("fs"),sysPath=require("path"),sysProcess=require("process"),child_process_1=require("child_process"),opts_parser_js_1=require("../shared/opts-parser.js"),fsix_js_1=require("../shared/vendor/fsix.js"),version_js_1=require("../shared/version.js"),consts_js_1=require("../shared/lib/consts.js"),rel_consts_js_1=require("../shared/rel-consts.js"),http_server_ex_js_1=require("../shared/vendor/http-server-ex.js");!function(e){var s=0,r=1,o=2,t=9e3,n="check",a="create",i="serve",c="render",l="gif",p="movie",m="story.gif",u="story.mp4",f="white",h="manual",d=consts_js_1.Consts.LL_ERROR,g=!1,_="",v="",y=[],j="win32"===sysProcess.platform,x=opts_parser_js_1.OptsParser.argOpts;function b(e,s,r){g&&(console.log("spawn cmdLine: "+e),console.log("args: "+s.join(" ")));var o=child_process_1.spawn(e,s);o.stdout.on("data",function(e){d>=consts_js_1.Consts.LL_SILENT&&console.log(e.toString())}),o.stderr.on("data",function(e){d>=consts_js_1.Consts.LL_SILENT&&console.error(e.toString())}),o.on("close",function(e){r()})}function P(e,s,r,o){g&&console.log("Copying Directory "+e+" to "+s),fsix_js_1.fsix.mkdirpSync(s),sysFs.readdirSync(e).forEach(function(t){if(!o||o(t)){var n=e+"/"+t,a=s+"/"+t,i=sysFs.statSync(n);if(i.isFile()){g&&console.log("Copying "+n+" to "+a);var c=fsix_js_1.fsix.readUtf8Sync(n);r&&(c=r(c,t)),sysFs.writeFileSync(a,c)}else i.isDirectory()&&P(n,a,r,o)}})}function w(){var e=fsix_js_1.fsix.toPosixSlash(v||"."),s=sysPath.posix.join(e,"story-frames/frame-report.json");if(sysFs.existsSync(s)&&(e=s),g&&(console.log("reportFileName: "+e),console.log("realReportFileName: "+s)),!sysFs.existsSync(e))throw"Report file "+e+" doesn't exist";var r=fsix_js_1.fsix.loadJsonSync(e);return r.dirname=sysPath.dirname(e),g&&console.log("report path: "+r.dirname),"./"===r.framespattern.substr(0,2)&&(r.framespattern=r.dirname+"/"+r.framespattern.substr(2)),r}x.port={param:"int",desc:"port for serve command. default is "+t},x.gif={param:"string",desc:"output gif filename. default is "+m},x.movie={param:"string",desc:"output movie filename. default is "+u},x.bkgMovie={param:"string",desc:"movie filename to be used as background to blend with transparent images"},x.noPlugins={desc:"creates a project without plugins"},x.noTypescript={desc:"creates a project without TypeScript files"},x.listDir={desc:"serve command lists the directory contents if url has the querystring '?dir'"},x.loop={param:"string",desc:"defines how many times a gif will loop. set to -1 if you don't won't it to loop"},x.moviePre={param:"array",allowOption:!0,desc:"arguments to be passed to ffmpeg before the arguments passed by abeamer"},x.moviePost={param:"array",allowOption:!0,desc:"arguments to be passed to ffmpeg after the arguments passed by abeamer"},x.gifPre={param:"array",allowOption:!0,desc:"arguments to be passed to gif generator(convert) before the arguments passed by abeamer"},x.gifPost={param:"array",allowOption:!0,desc:"arguments to be passed to gif generator(convert) after the arguments passed by abeamer"},x.gifBackground={param:"string",desc:'background color used to replace the alpha channel in gif generation.\nif this is value is set to "'+h+'" , no parameters relating are passed to the gif generator.\ndefault is '+h};try{!function(){switch(function(){for(var e=sysProcess.argv,t=1;-1===e[t-1].search(/abeamer/);)t++;return(_=e[t++])?"--version"===_?(console.log(version_js_1.VERSION),o):opts_parser_js_1.OptsParser.iterateArgOpts(!0,function(){return e[t++]},function(s,r){switch(s){case"@param":return v=r,void y.push(v);case"version":return console.log(version_js_1.VERSION),o;case"ll":(g=(d=r)>=consts_js_1.Consts.LL_VERBOSE)&&(console.log("Args: ["+e.join("],[")+"]"),console.log("Current Path: "+sysProcess.cwd()))}switch(_){case c:y.push("--"+s),r&&y.push(r)}})||r:s}()){case s:console.log("abeamer [command] [options] [project-name|report-name]\nThe commands are:\n    "+n+" checks if the all requirements are installed and configured\n    "+a+" creates a project with project-name\n    "+i+"  starts a live server. Use it in case you need to load the config from JSON file\n    "+c+" runs your project in the context of the headless browser.\n    "+l+"    creates an animated gif from the project-name or report-name\n    "+p+'  creates a movie from the project-name or report-name\n\n    e.g.\n      echo "checks if chrome, puppeteer, imagemagick, ffmpeg are installed and configured"\n      abeamer '+n+'\n\n      echo "create folder foo and copy necessary files"\n      abeamer '+a+' --width 640 --height 480 --fps 25 foo\n\n      cd foo\n\n      echo "start a live server"\n      echo "only required if you need to load your configuration from json file"\n      abeamer '+i+'\n\n      echo "generates the png files and a report on story-frames folder"\n      abeamer '+c+'\n\n      echo "creates story.gif file on story-frames folder"\n      abeamer '+l+'\n\n      echo "creates story.mp4 file on story-frames folder"\n      abeamer '+p+"\n\n      For more information, read:\n      https://abeamer.a-bentofreire.com/docs/latest/end-user/en/site/abeamer-cli/\n\n"),opts_parser_js_1.OptsParser.printUsage();break;case r:switch(g&&console.log("Run Command: "+_),_){case n:!function(){var e=0,s=5;function r(r,o,t){e++,console.log(e+". Check: "+r+" --\x3e "+(o?"OK":"Failed")),o||console.log("  TODO:"+t+"\n"),e===s&&console.log("\n")}function o(e,s,o,t){r(s+"="+o,e,"\n    "+t+"\n    Add to the shell startup script:\n"+(j?"SET":"export")+" "+s+"="+o)}function t(e,s,o,t,n){function a(o){r(s,o,"\n    ABeamer requires "+n+"\n    Either add the executable to the system path, or add to the shell startup script:\n"+(j?"set":"export")+" "+e+"=<absolute-path-to-"+s+">")}var i=sysProcess.env[e];i?a(sysFs.existsSync(i)):fsix_js_1.fsix.runExternal(s+" "+o,function(e,s,r){a(""===r&&s.match(t))})}console.log("\nChecking:\n"),o("true"===(sysProcess.env.PUPPETEER_SKIP_CHROMIUM_DOWNLOAD||"").toLowerCase(),"PUPPETEER_SKIP_CHROMIUM_DOWNLOAD","TRUE","by default puppeteer downloads Chromium which is doesn't support many features");var n,a=sysProcess.env.CHROME_BIN;a?o(sysFs.existsSync(a),"CHROME_BIN","<chrome-path>","CHROME_BIN points to a missing chrome executable"):o(!1,"CHROME_BIN","<chrome-path>","puppeteer uses by default Chromium, set CHROME_BIN with the absolute path to chrome web browser executable"),t("FFMPEG_BIN","ffmpeg","-version",/ffmpeg version/,"ffmpeg to generate movies"),t("IM_CONVERT_BIN","convert","--version",/Version: ImageMagick/,"ImageMagick convert program to generate gifs");try{n=require("puppeteer")}catch(e){}r("puppeteer",n,"\n   ABeamer requires puppeteer. Install using the following command\nnpm i puppeteer")}();break;case a:!function(){var e=fsix_js_1.fsix.toPosixSlash(v);if(!e)throw"Missing project name";if("-"===e[0]||-1!==e.search(/[\"\'\?\*\+]/)||-1!==e.search(/^[\.\/]+$/))throw"Error: "+e+" is not valid project name";if(sysFs.existsSync(e))throw"Error: Project "+e+" already exists";if(e.includes("/")){var s=sysPath.posix.dirname(e);fsix_js_1.fsix.mkdirpSync(s)}var r=fsix_js_1.fsix.toPosixSlash(__dirname)+"/..",o=r+"/gallery/hello-world",t=r+"/client/lib",n=x.width.value||rel_consts_js_1.RelConsts.DEFAULT_WIDTH,a=x.height.value||rel_consts_js_1.RelConsts.DEFAULT_HEIGHT,i=x.fps.value||rel_consts_js_1.RelConsts.DEFAULT_FPS,c=x.noPlugins.hasOption,l=x.noTypescript.hasOption;P(o,e,function(e,s){switch(sysPath.basename(s)){case"main.js":case"main.ts":l&&(e=e.replace(/^.*sourceMappingURL=.*$/m,"")),e=e.replace(/createStory\([^)]*\)/,"createStory(/*FPS:*/"+i+")");break;case"abeamer.ini":e=e.replace(/width:\s*\d+/,"width: "+n).replace(/height:\s*\d+/,"height: "+a);break;case"main.min.css":e=e.replace(/.abeamer-scene{width:\d+px;height:\d+px}/,".abeamer-scene{width:"+n+"px;height:"+a+"px}");break;case"index.html":if(!c){var o=fsix_js_1.fsix.loadJsonSync(r+"/client/lib/plugins/plugins-list.json"),t="",p="";e.replace(/^(.*)js\/abeamer\.min\.js(.*)$/m,function(e,s,r){return t=s,p=r,""}),e=e.replace(/^(.*js\/main\.js.*)$/m,function(e){return"\n          \x3c!-- remove the unnecessary plugins --\x3e\n"+o.map(function(e){return t+"plugins/"+e+"/"+e+".js"+p}).join("\n")+"\n\n"+e})}}return e},function(e){return!l||!e.match(/(?:js\.map|\.ts|tsconfig\.json)$/)}),P(t,e+"/abeamer",void 0,function(e){return!(l&&e.match(/(?:typings|\.ts)$/)||c&&e.match(/plugins$/)||e.match(/plugins-list\.json$/))}),d>consts_js_1.Consts.LL_SILENT&&console.log("Project "+e+" created.\n- frame-width: "+n+"px\n- frame-height: "+a+"px\n- fps: "+i+"\nTo modify the the frame dimensions, edit [abeamer.ini] and recompile the [css/main.scss] file.\nTo modify the fps, edit the [js/main.ts] file.\n")}();break;case i:e=sysFs.existsSync(sysPath.posix.join(__dirname,"../node_modules/marked/bin/marked")),S=sysFs.existsSync(sysPath.posix.join(__dirname,"../node_modules/highlight.js/lib/index.js")),E=x.port.value||t,O=x.listDir.hasOption,new http_server_ex_js_1.HttpServerEx.ServerEx(E,g,"EXIT_SERVER",O,e,S).start(),d>=consts_js_1.Consts.LL_SILENT&&(e&&console.log("Using markdown compiler"),console.log("Serving on http://localhost:"+E+"/"),O&&console.log("Directory listing on http://localhost:"+E+"/?dir"));break;case c:!function(){var e=(opts_parser_js_1.OptsParser.argOpts.server.value||rel_consts_js_1.RelConsts.DEFAULT_SERVER).toLowerCase();if(-1===rel_consts_js_1.RelConsts.SUPPORTED_SERVERS.indexOf(e))throw"Unknown "+e;v||x.config.value||x.url.value||y.push(".");var s=y.indexOf("--config");-1!==s&&(y[s]=y[s]+"__2"),y.splice(0,0,fsix_js_1.fsix.toPosixSlash(__dirname)+"/../server/server-agent-"+e+".js"),b(x.serverExec.value||(-1===rel_consts_js_1.RelConsts.NODE_SERVERS.indexOf(e)?e:"node"),y,function(){d>consts_js_1.Consts.LL_SILENT&&console.log("Server finished")})}();break;case l:!function(){var e=w(),s=x.gif.value||e.dirname+"/"+m,r=sysProcess.env.IM_CONVERT_BIN||"convert",o=["-delay","1x"+e.fps],t=opts_parser_js_1.OptsParser.computeScale(e.width,e.height);t&&o.push("-scale",t.join("x"));var n=x.loop.value||"0";o.push("-loop",n),o.push("-strip","-layers","optimize");var a=x.gifBackground.value||f;a!==h&&o.push("-background",a,"-alpha","remove"),o.push(e.framespattern.replace(/\%\d*d/,"*"),s),x.gifPre.multipleValue&&(o=x.gifPre.multipleValue.concat(o)),x.gifPost.multipleValue&&(o=o.concat(x.gifPost.multipleValue)),g&&console.log("\n"+r+" "+o.join(" ")+"\n"),b(r,o,function(){d>consts_js_1.Consts.LL_SILENT&&console.log("Created gif "+s)})}();break;case p:!function(){var e=w(),s=x.movie.value||e.dirname+"/"+u,r=x.bkgMovie.value,o=sysProcess.env.FFMPEG_BIN||"ffmpeg",t=opts_parser_js_1.OptsParser.computeScale(e.width,e.height),n=["-r",e.fps.toString(),"-f","image2"];t||n.push("-s",e.width+"x"+e.height),n.push("-i",e.framespattern,"-y"),t&&n.push("-vf","scale="+t.join("x")),r&&n.push("-vf","movie="+r+",hue=s=1[bg];[in]setpts=PTS,scale=-1:-1,pad=iw:ih:0:0:color=yellow[m]; [bg][m]overlay=shortest=1:x=0:y=0");var a=sysPath.extname(s),i="";switch(a){case".mp4":i="libx264";break;case".webm":i="libvpx-vp9"}i&&n.push("-vcodec",i),n.push(s),x.moviePre.multipleValue&&(n=x.moviePre.multipleValue.concat(n)),x.moviePost.multipleValue&&(n=n.concat(x.moviePost.multipleValue)),g&&(console.log("\next: "+a+"\n"),console.log("cmdLine:["+o+" "+n.join(" ")+"]\n\n")),b(o,n,function(){d>consts_js_1.Consts.LL_SILENT&&console.log("Created movie "+s)})}();break;default:throw"Unknown command "+_}}var e,S,E,O}()}catch(e){console.error(e.message||e.toString())}}(Cli||(Cli={}));