// ------------------------------------------------------------------------
// Copyright (c) 2018-2024 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License.
// ------------------------------------------------------------------------

var ABeamer,_abeamer,__extends=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();!function(e){function t(e){return Math.round(e-1e-4)}function r(e){for(var r=[],n=1;n<arguments.length;n++)r[n-1]=arguments[n];var a=0;return e.replace(/%(0*)((?:[1-9])?)([dfx])(?:\^([rfcd]))?/g,function(e,n,i,o,s){var u,c,p=r[a++];if(s)switch(s){case"r":p=Math.round(p);break;case"d":p=t(p);break;case"c":p=Math.ceil(p);break;case"f":p=Math.floor(p)}switch(o){case"d":c=(s?p:Math.floor(p)).toString();break;case"f":c=p.toString();break;case"x":c=p.toString(16)}if(u=c,i){var l=parseInt(i);l>c.length&&(u=new Array(l-c.length+1).join(n?"0":" ")+u)}return u})}e.VERSION="1.6.1",e.downRound=t,e.sprintf=r,e.LT_MSG=0,e.LT_WARN=1,e.LT_ERROR=2,e.LL_SILENT=0,e.LL_ERROR=1,e.LL_WARN=2,e.LL_VERBOSE=3,e.AS_UNKNOWN=0,e.AS_ADD_ANIMATION=1,e.AS_RENDERING=2,e.AS_STORY=3;var n,a,i,o={MESSAGE_PREFIX:"ABEAMER_",CMD_VALUE_SEP:"___",SERVER_SUFFIX:"abeamer-server=",LOG_LEVEL_SUFFIX:"loglevel=",TELEPORT_SUFFIX:"teleport=",RENDER_VAR_SUFFIX:"var=",WIDTH_SUFFIX:"frame-width=",HEIGHT_SUFFIX:"frame-height=",MSG_READY:"ready",MSG_RENDER:"render",MSG_RENDER_FINISHED:"render-finished",MSG_LOG_MSG:"log",MSG_LOG_WARN:"warn",MSG_LOG_ERROR:"error",MSG_SET_FPS:"set-fps",MSG_SET_FRAME_NR:"set-frame-nr",MSG_SET_FRAME_COUNT:"set-frame-count",MSG_TELEPORT:"teleport",MSG_EXIT:"exit",MSG_SERVER_READY:"server-ready",MSG_RENDER_DONE:"render-done"},s={_default:{map:{},features:{hasLogging:!0}},puppeteer:{map:{},features:{hasLogging:!0}}};function u(e){var t,r=s[e]||s._default;return t=r.map,Object.keys(t).forEach(function(e){de[e]=t[e]}),r.features}function c(e,t){return t&&(e=e.replace(/%(\w+)%/g,function(e,r){return t[r].toString()})),e}function p(e){if(void 0!==e){if("string"==typeof e)e=a[e];else if("function"==typeof e)return e;switch(e){case a.round:return Math.round;case a.downRound:return t;case a.ceil:return Math.ceil;case a.floor:return Math.floor}}}function l(e,t,r,n){if(void 0===e){if(!t)return;e=t}if("string"==typeof e){var a=X(e,n);void 0!==a&&(e=a)}return"function"==typeof e?e(n):e}function h(e){throw e}function f(e,t){h(c(e,t))}function d(e,t,r){e&&h(c(t,r))}function _(e,r,n,a){switch(n){case i.f:return e.toString();case i.ms:e*=1e3;break;case i.m:e/=60}var o=e/r,s=Math.pow(10,a||4);return(t(o*s)/s).toString()+i[n]}function m(e,r,n,a,o){void 0===o&&(o=!0),void 0!==e&&""!==e||(e=n);var s="",u=r.story;"function"==typeof e&&(e=e(r));var c=u.defaultUnit,p="string"==typeof e;if(p){var l=X(e,r);void 0!==l&&(p="string"==typeof(e=l))}if(p){var h=e.match(/^([+\-])?([\d\.]+)([\w%]+)$/)||["","","",""],f=h[1],d=h[2],_=h[3];if(void 0===(c=i[_]))throw"Unknown time of "+e;e=parseFloat(d),s=f}var m=e;switch(c){case i.ms:m=m*u.fps/1e3;break;case i.s:m*=u.fps;break;case i.m:m=m*u.fps*60;break;case i["%"]:m=n*m/100}switch(s){case"+":m=a+m;break;case"-":m=a-m}return o?t(m):m}!function(e){e.MustNatPositive="The value of %p% must be a natural positive",e.MustNatNotNegative="The value of %p% must be a natural non-negative",e.MustBeANumber="The value of %p% must be a number",e.MustBeAString="The value of %p% must be textual",e.MustBeANumberOrExpr="The value of %p% must be a number or an expression",e.MustBeAStringOrExpr="The value of %p% must be textual or an expression",e.Unknown="Unknown %p%",e.UnknownOf='Unknown "%type%" %p%',e.UnknownType="Unknown type of %p%",e.NoEmptyField="Field %p% can not be empty",e.NoEmptySelector="Selector %p% can not be empty",e.NoCode="Code Handler is not allowed",e.OutOfScope="%p% out of scope",e.ExpHasErrors="Expression %e% has errors: %err%",e.WrongNrParams="Function %p% has the wrong number of input parameters",e.WrongParamType="Function %p% has the wrong type in parameter: %i%",e.ValueTypeError="Value %p% must be a number or an expression",e.UnaryErr="Unary operators only support numerical values",e.flyover="flyover",e.task="task",e.pos="position",e.startScene="startScene",e.endScene="endScene"}(n=e.Msgs||(e.Msgs={})),e.i8nMsg=c,function(e){e[e.none=0]="none",e[e.round=1]="round",e[e.ceil=2]="ceil",e[e.floor=3]="floor",e[e.downRound=4]="downRound"}(a=e.RoundFuncName||(e.RoundFuncName={})),e.parseRoundFunc=p,e.parseHandler=l,e.parseEnum=function(e,t,r){return void 0===e&&(e=r),void 0===e?r:"string"==typeof e?t[e]:e},e.throwErr=h,e.throwI8n=f,e.throwIf=function(e,t){e&&h(t)},e.throwIfI8n=d,e.isPositiveNatural=function(e){return"number"==typeof e&&e>0&&Math.abs(Math.floor(e)-e)<1e-7},e.isNotNegativeNatural=function(e){return"number"==typeof e&&e>=0&&Math.abs(Math.floor(e)-e)<1e-7},e.isPositive=function(e){return"number"==typeof e&&e>0},e.isNotNegative=function(e){return"number"==typeof e&&e>=0},function(e){e[e.f=0]="f",e[e.ms=1]="ms",e[e.s=2]="s",e[e.m=3]="m",e[e["%"]=4]="%"}(i=e.TimeUnit||(e.TimeUnit={})),e.frame2Time=_,e.parseTimeHandler=m;var y={};function v(e,t,r){V(e,t,1,void 0,r)}function g(e,t,r){t.checkParams(t,1,[2]),t.res.paType=2,t.res.sValue=r(e[0].sValue)}y.sin=function(e,t){v(e,t,Math.sin)},y.cos=function(e,t){v(e,t,Math.cos)},y.tan=function(e,t){v(e,t,Math.tan)},y.round=function(e,t){v(e,t,Math.round)},y.downRound=function(e,r){v(e,r,t)},y.ceil=function(e,t){v(e,t,Math.ceil)},y.floor=function(e,t){v(e,t,Math.floor)},y.sqrt=function(e,t){v(e,t,Math.sqrt)},y.exp=function(e,t){v(e,t,Math.exp)},y.log=function(e,t){v(e,t,Math.log)},y.log10=function(e,t){v(e,t,Math.log10)},y.abs=function(e,t){v(e,t,Math.abs)},y.sign=function(e,t){v(e,t,function(e){return e<0?-1:e>0?1:0})},y.random=function(e,t){t.checkParams(t,0),t.res.paType=1,t.res.numValue=Math.random()},y.toNumber=function(e,t){t.checkParams(t,1,[2]),t.res.paType=1,t.res.numValue=parseFloat(e[0].sValue)},y.toString=function(e,t){t.checkParams(t,1,[1]),t.res.paType=2,t.res.sValue=e[0].numValue.toString()},y.uppercase=function(e,t){g(e,t,function(e){return e.toUpperCase()})},y.lowercase=function(e,t){g(e,t,function(e){return e.toUpperCase()})},y.capitalize=function(e,t){g(e,t,function(e){return e.replace(/\b(\w)/,function(e,t){return t.toUpperCase()})})},y.substr=function(e,t){t.checkParams(t,3,[2,1,1]),t.res.paType=2,t.res.sValue=e[0].sValue.substr(e[1].numValue,e[2].numValue<0?void 0:e[2].numValue)},y.iff=function(e,t){t.checkParams(t,3,[1,0,0]);var r=e[e[0].numValue?1:2];t.res.paType=r.paType,t.res.sValue=r.sValue,t.res.numValue=r.numValue},y.case=function(e,t){var r=e[Math.round(e[0].numValue)+1];t.res.paType=r.paType,t.res.sValue=r.sValue,t.res.numValue=r.numValue},y.get=function(e,t){t.checkParams(t,2,[3,1]);var r=Math.round(e[1].numValue),n=e[0].arrayValue;(r<0||r>=n.length)&&h("Invalid indexing"),t.res.paType=1,t.res.numValue=n[r]},y.slice=function(e,t){t.checkParams(t,3,[3,1,1]);var r=Math.round(e[1].numValue),n=Math.round(e[2].numValue),a=e[0].arrayValue;(r<0||r>=a.length||n<0||n>=a.length)&&h("Invalid indexing"),t.res.paType=3,t.res.arrayValue=a.slice(r,n)};var T,S={e:Math.E,pi:Math.PI,deg2rad:Math.PI/180,rad2deg:180/Math.PI};function E(t,r){if(void 0===r&&(r=0),void 0===t||void 0===t[r])return!1;var n=t.codePointAt(r);return-1!==e.CharRanges.findIndex(function(e){return n>=e[0]&&n<=e[1]})}function P(e){return e>="0"&&e<="9"}function b(e){return P(e)||E(e)}function A(e){return void 0!==e&&"="===e[0]}e.getVars=function(){return S},e.CharRanges=[["A".charCodeAt(0),"Z".charCodeAt(0)],["a".charCodeAt(0),"z".charCodeAt(0)]],e.isCharacter=E,e.isDigit=P,e.isCharacterOrNum=b,e.isExpr=A,function(e){e[e["["]=2]="[",e[e["]"]=3]="]",e[e["("]=5]="(",e[e[")"]=6]=")",e[e["+"]=8]="+",e[e["-"]=9]="-",e[e["*"]=10]="*",e[e["/"]=11]="/",e[e["%"]=12]="%",e[e[","]=4]=",",e[e["=="]=13]="==",e[e["!="]=14]="!=",e[e["<"]=15]="<",e[e[">"]=16]=">",e[e["<="]=17]="<=",e[e[">="]=18]=">="}(T||(T={}));var I,F=[0,19,19,19,19,20,20,1,13,13,14,14,14,10,10,11,11,11,11,6,5,16],R=[0,1,2,3,10,5,6,4,7,7,9,9,9,9,9,9,9,9,9,9,9,8];function k(e,t){return void 0!==e&&("_"===e||(t?E(e):b(e)))}function w(e,t,r,n,a){var i=typeof t;if(void 0===t&&O(e,"Unknown variable "+r),"string"===i)e.token.paType=2,e.token.sValue=t;else if("number"===i)e.token.paType=1,e.token.numValue=t,e.token.sValue=void 0,e.token.arrayValue=void 0;else if("object"===i){if(Array.isArray(t))e.token.paType=3,e.token.arrayValue=t,e.token.sValue=void 0,e.token.numValue=void 0;else if("."===n[a]){for(var o=++a;k(n[a],o===a);)a++;var s=n.substring(o,a);s||O(e,"Invalid object variable "+r),a=w(e,t[s],r+"."+s,n,a)}if("["===n[a]){o=++a;for(var u=1;u>0;){switch(n[a]){case"[":u++;break;case"]":u--;break;case void 0:O(e,"Invalid  variable indexing "+r)}a++}var c="="+n.substring(o,a-1),p=B(c,e.args);w(e,t[parseInt(p)],r,c,1),a++}}else"boolean"===i?(e.token.paType=1,e.token.numValue=t?1:0,e.token.sValue=void 0,e.token.arrayValue=void 0):O(e,"Unsupported type of "+r);return a}function C(e,t){var r;function n(t){e.token.sValue=a.substring(r,i),e.token.tkType=t,e.token.tkClass=R[t]}var a=e.expr,i=e.pos;for(e.token.tkClass=0;;){for(var o=a[i];" "===o;)o=a[++i];if(r=i,void 0===o)break;if("_"===o||E(o)){for(;k(a[++i],!1););if("("===a[i]){n(1),"not"===e.token.sValue?(e.token.tkType=21,e.token.tkClass=8):i++}else{n(7);var s=e.token.sValue,u=["not","and","or"].indexOf(s);-1!==u?(e.token.tkType=[21,19,20][u],e.token.tkClass=0!==u?9:8):i=w(e,e.args.vars[s],s,a,i)}break}if(t&&("-"===o||"+"===o)&&P(a[i+1])&&(o=a[++i]),P(o)){do{o=a[++i]}while(o&&(P(o)||"."===o));n(7),e.token.paType=1,e.token.numValue=parseFloat(e.token.sValue),e.token.sValue=void 0;break}if("'"===o){var c=void 0;do{c=o,o=a[++i]}while(("'"!==o||"\\"===c)&&void 0!==o);r++,n(7),e.token.sValue=e.token.sValue.replace(/\\([n'])/g,function(e,t){switch(t){case"n":return"\n";case"'":return"'"}}),e.token.paType=2,i++;break}-1!=="=!<>".indexOf(o)&&"="===a[i+1]&&(o+="=",i++);var p=T[o]||0;0===p&&O(e,"Unknown token "+o+" in position "+i,e.token),i++,n(p);break}var l=e.token.tkClass;return e.pos=i,e.token.canBinOp=7===l||9===l,l}function N(e,t){var r=t.sValue,n=y[r];n||O(e,"Unknown function: "+r,t);var a={canBinOp:!1,tkClass:4,tkType:7};return e.res=a,e.token=t,n(t.funcParams,e),a}function M(e,t){return{paType:3,sValue:void 0,numValue:void 0,arrayValue:t.funcParams.map(function(e){return e.numValue}),canBinOp:!1,tkClass:4,tkType:7}}function O(e,t,r){f(n.ExpHasErrors,{e:e.expr,err:t||""})}function x(e,t,r){var a=e.token.funcParams;t>=0&&a.length!==t&&O(e,c(n.WrongNrParams,{p:e.token.sValue})),r&&r.forEach(function(t,r){var i=a[r];(!i||i.paType!==t&&0!==t)&&O(e,c(n.WrongParamType,{p:e.token.sValue,i:r}))})}function V(e,t,r,a,i){var o;if(1===e.length&&3===e[0].paType){if(o=e[0].arrayValue,a&&o.length!==a&&O(t,c(n.WrongNrParams,{p:t.token.sValue})),r!==a)return o.forEach(function(e,t){o[t]=i(e)}),t.res.paType=3,void(t.res.arrayValue=o)}else if(r>=0&&e.length!==r&&O(t,c(n.WrongNrParams,{p:t.token.sValue})),o=e.map(function(e,r){return 1!==e.paType&&O(t,c(n.WrongParamType,{p:t.token.sValue,i:r})),e.numValue}),1===r)return t.res.paType=1,void(t.res.numValue=i(o[0]));var s=i(o);"number"==typeof s?(t.res.paType=1,t.res.numValue=s):(t.res.paType=3,t.res.arrayValue=s)}function L(e,t){return F[e.tkType]>=F[t.tkType]}function D(e,t,r){1!==r.paType&&O(e,n.UnaryErr),9===t.tkType?r.numValue=-r.numValue:21===t.tkType&&(r.numValue=r.numValue?0:1)}function U(e,t,r,n){var a,i=1!==r.paType||1!==n.paType,o=3===r.paType,s=3===n.paType;function u(){i&&O(e,"This op only supports numbers")}function c(e,t){if(o||s)o&&s||h("Can only add 2 arrays"),r.arrayValue.length!==n.arrayValue.length&&h("Both arrays must have the same value"),r.arrayValue.forEach(function(t,a){r.arrayValue[a]=e(t,n.arrayValue[a])}),r.paType=3,a=void 0;else if(i){if(t)return!1;u()}else a=e(r.numValue,n.numValue);return!0}switch(t.tkType){case 8:if(!c(function(e,t){return e+t},!0))return r.sValue=(1===r.paType?r.numValue.toString():r.sValue)+(1===n.paType?n.numValue.toString():n.sValue),void(r.paType=2);break;case 9:c(function(e,t){return e-t});break;case 10:c(function(e,t){return e*t});break;case 11:c(function(e,t){return e/t});break;case 12:c(function(e,t){return e%t});break;case 13:u(),a=r.numValue===n.numValue?1:0;break;case 14:u(),a=r.numValue!==n.numValue?1:0;break;case 15:u(),a=r.numValue<n.numValue?1:0;break;case 16:u(),a=r.numValue>n.numValue?1:0;break;case 17:u(),a=r.numValue<=n.numValue?1:0;break;case 18:u(),a=r.numValue>=n.numValue?1:0;break;case 19:u(),a=r.numValue&&n.numValue?1:0;break;case 20:u(),a=r.numValue||n.numValue?1:0}r.numValue=a}function B(e,t){return function(e){var t,r,n,a=[],i=0,o=-1,s=0,u=[];function c(){a.push(t),o++}function p(){for(;o>1&&o>s+1&&(r=a[s+1]).canBinOp;){var t=a[s],n=a[s+2];U(e,r,t,n),a.splice(s+1,2),o-=2}}function l(){for(;o>2&&(r=a[o-1]).canBinOp;){var t=a[o-2],n=a[o],i=a[o-3];if(!L(r,i))break;U(e,r,t,n),a.length=o-1,o-=2}}function h(){p(),s!==o&&O(e,""),t=a.pop(),o--}for(e.req=e;;){e.token={};var f=C(e,2!==i);if(t=e.token,0===f)break;switch(f){case 4:2===i?O(e,""):1!==i||-1===[7,8].indexOf(a[o].tkClass)||0!==o&&4===a[o-1].tkClass||(i=0,n=a[o],a.length=o,o--,D(e,r=n,t)),i=2,c(),l();break;case 2:case 1:t.funcParams=[];case 5:2===i&&O(e,""),c(),s=o+1,u.push(s),i=0;break;case 10:case 6:case 3:s||O(e,"Missing starting parenthesis");var d=a[s-1],_=10===f,m=1===d.tkClass,y=2===d.tkClass;!_||m||y||O(e,"Missing function"),!m&&!y||_?h():(s!==o+1&&(h(),d.funcParams.push(t)),t=m?N(e,d):M(0,d)),_?(d.funcParams.push(t),i=0):(a[o]=t,u.pop(),s=u[u.length-1]||0,i=2);break;case 8:case 7:if(0===i){7===f&&(i=1),c();break}case 9:2!==i&&O(e,""),o>0&&4===a[o].tkClass&&(r=a[o-1]).canBinOp&&L(r,t)&&p(),i=1,c()}}return p(),1!==a.length&&O(e,"Stack not empty"),t=a[0],4!==a[o].tkClass&&O(e,"Not a value"),function(e){return 2===e.paType?e.sValue:3===e.paType?e.arrayValue:e.numValue}(t)}({args:t,checkParams:x,expr:e,pos:1})}function X(e,t){return A(e)?B(e,t):void 0}function G(e,t,r){if(!A(e))return t;var a=B(e,r);return r.isStrict&&void 0!==a&&"number"!=typeof a&&f(n.MustBeANumber,{p:e}),void 0!==a?parseFloat(a):t}function j(e,t){var r=B(e,t);return!t.isStrict||void 0!==r&&"string"==typeof r||f(n.MustBeAString,{p:e}),r}function W(e,t,r){if(!A(e))return t;var a=B(e,r);return r.isStrict&&void 0!==a&&"string"!=typeof a&&f(n.MustBeAString,{p:e}),void 0!==a?a:t}function H(e,t,r){if(r.isStrict&&void 0!==e){var a=typeof e;"string"!==a&&"number"!==a&&f(n.MustBeANumberOrExpr,{p:e})}return G(e,void 0!==e?e:t,r)}e.arrayInputHelper=V,e.calcExpr=B,e.ifExprCalc=X,e.ifExprCalcNum=G,e.calcStr=j,e.ifExprCalcStr=W,e.ExprOrNumToNum=H,e.ExprOrStrToStr=function(e,t,r){return r.isStrict&&void 0!==e&&"string"!=typeof e&&f(n.MustBeAStringOrExpr,{p:e}),W(e,void 0!==e?e:t,r)},function(e){e[e.linear=0]="linear",e[e.easeInQuad=1]="easeInQuad",e[e.easeOutQuad=2]="easeOutQuad",e[e.easeInOutQuad=3]="easeInOutQuad",e[e.easeInCubic=4]="easeInCubic",e[e.easeOutCubic=5]="easeOutCubic",e[e.easeInOutCubic=6]="easeInOutCubic",e[e.easeInQuart=7]="easeInQuart",e[e.easeOutQuart=8]="easeOutQuart",e[e.easeInOutQuart=9]="easeInOutQuart",e[e.easeInQuint=10]="easeInQuint",e[e.easeOutQuint=11]="easeOutQuint",e[e.easeInOutQuint=12]="easeInOutQuint",e[e.easeInSine=13]="easeInSine",e[e.easeOutSine=14]="easeOutSine",e[e.easeInOutSine=15]="easeInOutSine",e[e.easeInExpo=16]="easeInExpo",e[e.easeOutExpo=17]="easeOutExpo",e[e.easeInOutExpo=18]="easeInOutExpo",e[e.easeInCirc=19]="easeInCirc",e[e.easeOutCirc=20]="easeOutCirc",e[e.easeInOutCirc=21]="easeInOutCirc",e[e.easeInElastic=22]="easeInElastic",e[e.easeOutElastic=23]="easeOutElastic",e[e.easeInOutElastic=24]="easeInOutElastic",e[e.easeInBack=25]="easeInBack",e[e.easeOutBack=26]="easeOutBack",e[e.easeInOutBack=27]="easeInOutBack",e[e.easeInBounce=28]="easeInBounce",e[e.easeOutBounce=29]="easeOutBounce",e[e.easeInOutBounce=30]="easeInOutBounce"}(I=e.EasingName||(e.EasingName={}));var q={linear:function(e){return e}};function Q(e){return I[e]}var Y,z,K,J,Z=["linear","swing","_default","def"];function ee(e,t,r){return S.t=e,parseFloat(B(t._expression,r))}function te(e){return Y[e]||Q(e)}function re(e){if("string"==typeof e&&(e=z[e]),"number"==typeof e)switch(e){case z.abs:case z.clip:return function(e){return Math.abs(e)}}return e}Object.keys($.easing).forEach(function(e){-1===Z.indexOf(e)&&(q[e]=function(t){return $.easing[e](0,t,0,1,1)})}),function(e){e[e.harmonic=1e3]="harmonic",e[e.damped=1001]="damped",e[e.pulsar=1002]="pulsar"}(Y=e.OscillatorName||(e.OscillatorName={})),function(e){e[e.none=0]="none",e[e.clip=1]="clip",e[e.abs=2]="abs"}(z=e.NegativeBuiltInFuncs||(e.NegativeBuiltInFuncs={})),function(e){e[e.normal=0]="normal",e[e.sine=1]="sine",e[e.random=2]="random",e[e.positiveRandom=3]="positiveRandom"}(K=e.PulsarType||(e.PulsarType={})),q.harmonic=function(e,t){t._isPrepared||(t._cycles=t.cycles||1,t._negativeHandler=re(t.negativeHander),t._shift=t.shift||0);var r=t._cycles,n=Math.sin(2*Math.PI*(e+t._shift)*r);return t._negativeHandler?t._negativeHandler(n):n},q.damped=function(e,t){t._isPrepared||(t._isPrepared=!0,t._curFrequency=t.frequency||.1,t._curAmplitude=1,t._scale=1-(t.friction||.1),t._shift=0,t._negativeHandler=re(t.negativeHander));var r=e-t._shift;r>=t._curFrequency&&(t._shift=e,t._curFrequency=t._curFrequency*t._scale,t._curAmplitude=t._curAmplitude*t._scale,r=e-t._shift);var n=Math.sin(2*Math.PI*(r/t._curFrequency))*t._curAmplitude;return t._negativeHandler?t._negativeHandler(n):n},q.pulsar=function(e,t){t._isPrepared||(t._isPrepared=!0,t.midpoint=t.midpoint||.5,t.spread=t.spread||.1,t.type=t.type||K.normal,"string"==typeof t.type&&(t.type=K[t.type]));var r=t.midpoint,n=t.spread;if(e<=r-n||e>=r+n)return 0;switch(t.type){case K.normal:var a=(e-(r-n))/n;return e>r&&(a=2-a),(Math.exp(a)-1)/(Math.E-1);case K.sine:var i=(e-(r-n))/n;return Math.sin(Math.PI*i);case K.random:return 2*Math.random()-1;case K.positiveRandom:return Math.random()}},function(e){e[e.line=0]="line",e[e.rect=1]="rect",e[e.circle=2]="circle",e[e.ellipse=3]="ellipse"}(J=e.PathName||(e.PathName={}));var ne={};function ae(e){return J[e]}function ie(e,t,r,n){S.t=e;var a=B(t._expression,n);return Array.isArray(a)?a:[parseFloat(a)]}function oe(e,t,r,n,a,i){return t._isPrepared||(t._isPrepared=!0,t._centerX=H(t.centerX,0,i),t._centerY=H(t.centerY,0,i),t._radiusX=H(r,1,i),t._radiusY=H(n,1,i)),e=2*Math.PI*e,[Math.cos(e)*t._radiusX+t._centerX,Math.sin(e)*t._radiusY+t._centerY]}ne.line=function(e,t,r,n){t._isPrepared||(t._x0=H(t.x0,0,n),t._y0=H(t.y0,0,n),t._sx=H(t.x1,1,n)-t._x0,t._sy=H(t.y1,1,n)-t._y0);return[t._sx*e+t._x0,t._sy*e+t._y0]},ne.rect=function(e,t,r,n){if(!t._isPrepared){t._isPrepared=!0,t._x0=H(t.x0,0,n),t._y0=H(t.y0,0,n),t._x1=H(t.x1,1,n),t._y1=H(t.y1,1,n),t._dx=t._x1-t._x0,t._dy=t._y1-t._y0;var a=1/(2*(t._dx+t._dy));t._xSlot=t._dx*a,t._ySlot=t._dy*a}if(e<0)return[t._x0,t._y0];if(e<=t._xSlot)return[t._x0+t._dx*e/t._xSlot,t._y0];if((e-=t._xSlot)<=t._ySlot)return[t._x1,t._y0+t._dy*e/t._ySlot];if((e-=t._ySlot)<=t._xSlot)return[t._x1-t._dx*e/t._xSlot,t._y1];if((e-=t._xSlot)<=t._ySlot)return[t._x0,t._y1-t._dy*e/t._ySlot];return[t._x1,t._y1]},ne.circle=function(e,t,r,n){return oe(e,t,t.radius,t.radius,0,n)},ne.ellipse=function(e,t,r,n){return oe(e,t,t.radiusX,t.radiusY,0,n)},e.TR_EXIT=0,e.TR_DONE=1,e.TR_INTERACTIVE=2,e.TS_INIT=0,e.TS_ANIME_LOOP=1,e.TS_TELEPORT=2;var se={};function ue(t,r,a,i){var o,s=t.handler;switch(i.user=t.params,typeof s){case"string":o=se[s];break;case"function":o=s,d(a,n.NoCode)}o||f(n.UnknownOf,{type:n.task,p:s});var u={func:o,name:s,params:t.params||{},animeIndex:-1};return a&&(t.handler=s,o(r,u,u.params,e.TS_TELEPORT,i)),u}function ce(e,t,n,a){if("object"==typeof e&&(e=e[n%e.length]),!1===t)return e;a.vars.i=n;var i=X(e,a);return void 0!==i?i.toString():r(e,n)}se.factory=function(t,r,n,a,i){switch(a){case e.TS_INIT:var o=n.tag||"div",s=G(n.count,n.count,i),u=-1===["img"].indexOf(o),c=i.scene.getElementAdapters(t.selector);return i.vars.elCount=c.length,c.forEach(function(e,t){i.vars.elIndex=t;for(var r=[],a=function(e){var t=["<"+o];(n.attrs||[]).forEach(function(r){var n=ce(r.value,r.isFormatted,e,i);t.push(" "+r.name+'="'+n+'"')}),t.push(">"),t.push(ce(n.content||"",n.isContentFormatted,e,i)),u&&t.push("</"+o+">"),r.push(t.join(""))},c=0;c<s;c++)a(c);e.setProp("html",r.join("\n"),i)}),e.TR_EXIT}};var pe,le={};le.info=function(t,r,n,a){switch(n){case e.TS_INIT:r._elAdapters||(r._elAdapters=a.story.getElementAdapters(r.selector||".info-flyover"));break;case e.TS_ANIME_LOOP:var o=r.format||"${storyFrameNr}",s=a.story;r._elAdapters.forEach(function(e){var t=o.replace(/\$\{(\w+)\}/g,function(e,t){switch(t){case"storyFrameNr":return s.renderFramePos.toString();case"storyElapsedMS":return _(s.renderFramePos,s.fps,i.ms);case"storyElapsedS":return _(s.renderFramePos,s.fps,i.s);case"storyElapsedM":return _(s.renderFramePos,s.fps,i.m)}return""});e.setProp("text",t,a)})}},le["video-sync"]=function(t,r,n,a){switch(n){case e.TS_INIT:if(!r._elAdapters){r._elAdapters=a.story.getElementAdapters(r.selector||"#video");break}case e.TS_ANIME_LOOP:var i=a.story.fps;a.hasServer&&!1===r.serverRender||r._elAdapters.forEach(function(e){var t=a.story.renderFramePos/i;e.setProp("currentTime",t,a)})}},function(e){e[e.Custom=0]="Custom",e[e.ImageLoad=1]="ImageLoad",e[e.MediaSync=2]="MediaSync"}(pe=e.WaitForWhat||(e.WaitForWhat={}));var he=function(){function e(){this.props={},this.propsChanged=!1}return e.prototype.animateProp=function(e,t){this.onAnimateProp&&this.onAnimateProp(e,t)},e.prototype.animateProps=function(e){this.onAnimateProps&&this.onAnimateProps(e)},e.prototype.getProp=function(e){return this.props[e]},e.prototype.setProp=function(e,t){this.props[e]=t,"uid"!==e&&(this.propsChanged=!0,this.animateProp(e,t))},e.prototype.frameRendered=function(e){this.propsChanged&&(this.animateProps(e),this.propsChanged=!1)},e}();e.SimpleVirtualAnimator=he,e.browser={isMsIE:!1,vendorPrefix:"",prefixedProps:[]},e.DPT_ID=0,e.DPT_VISIBLE=1,e.DPT_ATTR=2,e.DPT_ATTR_FUNC=3,e.DPT_STYLE=4,e.DPT_PIXEL=5,e.DPT_DUAL_PIXELS=6,e.DPT_CLASS=7,e.DPT_MEDIA_TIME=8,e.DPT_SRC=9,e.DPT_ELEMENT=10;var fe={element:[e.DPT_ELEMENT,""],uid:[e.DPT_ATTR_FUNC,"data-abeamer"],id:[e.DPT_ATTR,"id"],html:[e.DPT_ATTR,"innerHTML"],text:[e.DPT_ATTR,"textContent"],innerHTML:[e.DPT_ATTR,"innerHTML"],outerHML:[e.DPT_ATTR,"outerHML"],textContent:[e.DPT_ATTR,"textContent"],currentTime:[e.DPT_MEDIA_TIME,"currentTime"],src:[e.DPT_SRC,"src"],class:[e.DPT_CLASS,"className"],visible:[e.DPT_VISIBLE,""],left:[e.DPT_PIXEL,"left"],right:[e.DPT_PIXEL,"right"],bottom:[e.DPT_PIXEL,"bottom"],top:[e.DPT_PIXEL,"top"],width:[e.DPT_PIXEL,"width"],height:[e.DPT_PIXEL,"height"],"width-height":[e.DPT_DUAL_PIXELS,["width","height"]],"left-top":[e.DPT_DUAL_PIXELS,["left","top"]],"right-top":[e.DPT_DUAL_PIXELS,["right","top"]],"left-bottom":[e.DPT_DUAL_PIXELS,["left","bottom"]],"right-bottom":[e.DPT_DUAL_PIXELS,["right","bottom"]]},de={};var _e=function(){function e(){}return e.prototype.waitFor=function(e,t,r){},e.prototype.frameRendered=function(e){},e}();e._AbstractAdapter=_e;var me=function(e){function t(t){return e.call(this)||this}return __extends(t,e),t.prototype.getId=function(e){return this.getProp("id",e)},t.prototype._clearComputerData=function(){},t}(_e);function ye(t,r,n,a){var i=fe[r]||[e.DPT_STYLE,r],o=i[0],s=i[1],u=t.htmlElement;switch(o){case e.DPT_CLASS:if(n&&-1!==n.search(/(?:^| )[\-+]/)){n.split(/\s+/).forEach(function(e){var t=e[0];"-"===t?u.classList.remove(e.substr(1)):"+"===t?u.classList.add(e.substr(1)):u.classList.add(e)});break}case e.DPT_ID:case e.DPT_ATTR:u[s]=n;break;case e.DPT_MEDIA_TIME:Ce(u,a,n);break;case e.DPT_VISIBLE:var c=u["data-abeamer-display"],p=u.style.display||t.getComputedStyle().display;!1!==n&&"false"!==n&&0!==n?"none"===p&&(u.style.display=c||("SPAN"===u.tagName?"inline":"block")):(c||(u["data-abeamer-display"]=p),u.style.display="none");break;case e.DPT_SRC:case e.DPT_ATTR_FUNC:u.setAttribute(s,n),o===e.DPT_SRC&&"IMG"===u.tagName&&we(u,a);break;case e.DPT_STYLE:var l=de[s]||s;u.style[l]=n;break;case e.DPT_PIXEL:u.style[s]="number"==typeof n?n+"px":n;break;case e.DPT_DUAL_PIXELS:var h=n.split(",");s.forEach(function(e,t){u.style[e]=h[t]+"px"})}}function ve(e){return null===e?void 0:e}function ge(t,r,n){var a=fe[r]||[e.DPT_STYLE,r],i=a[0],o=a[1];switch(i){case e.DPT_ELEMENT:return t.htmlElement;case e.DPT_MEDIA_TIME:case e.DPT_CLASS:case e.DPT_ID:case e.DPT_ATTR:return ve(t.htmlElement[o]);case e.DPT_VISIBLE:var s=t.htmlElement.style.display||t.getComputedStyle().display;return""===s||"none"!==s;case e.DPT_SRC:case e.DPT_ATTR_FUNC:return ve(t.htmlElement.getAttribute(o));case e.DPT_PIXEL:case e.DPT_STYLE:var u=de[o]||o;return t.htmlElement.style[u]||t.getComputedStyle()[u]}}e._ElementAdapter=me;var Te=function(e){function t(t){var r=e.call(this,t)||this;return r.isVirtual=!1,r.htmlElement=t,r}return __extends(t,e),t.prototype.getComputedStyle=function(){var e=this.__compStyle;return e||(e=window.getComputedStyle(this.htmlElement),this.__compStyle=e),e},t.prototype.getProp=function(e,t){return ge(this,e)},t.prototype.setProp=function(e,t,r){ye(this,e,t,r)},t.prototype._clearComputerData=function(){},t.prototype.waitFor=function(e,t,r){switch(e.what){case pe.ImageLoad:we(this.htmlElement,r);break;case pe.MediaSync:Ce(this.htmlElement,r,e.value)}},t}(me),Se=(function(e){function t(){return null!==e&&e.apply(this,arguments)||this}__extends(t,e)}(me),function(e){function t(t){var r=e.call(this,t)||this;return r.isVirtual=!0,r.vElement=t,r}return __extends(t,e),t.prototype.getProp=function(e,t){return this.vElement.getProp(e,t)},t.prototype.setProp=function(e,t,r){this.vElement.setProp(e,t,r)},t.prototype.waitFor=function(e,t,r){this.vElement.waitFor(e,t,r)},t.prototype.frameRendered=function(e){this.vElement.frameRendered&&this.vElement.frameRendered(e)},t}(me)),Ee=function(e){return void 0!==e.getProp},Pe=function(e){return"%"===e[0]};var be=function(e){return"object"==typeof e&&void 0!==e.query},Ae=function(e){function t(t){return e.call(this)||this}return __extends(t,e),t}(_e);e._SceneAdapter=Ae;var Ie=function(e){function t(t){var r=e.call(this,t)||this;return r.$scene="string"==typeof t?$(t):t,d(!r.$scene.length,n.NoEmptySelector,{p:t}),r.htmlElement=r.$scene.get(0),r.isVirtual=!1,r}return __extends(t,e),t.prototype.getComputedStyle=function(){var e=this.__compStyle;return e||(e=window.getComputedStyle(this.htmlElement),this.__compStyle=e),e},t.prototype.getProp=function(e,t){switch(e){case"fps":return parseInt(document.body.getAttribute("data-fps"));case"frame-width":return document.body.clientWidth;case"frame-height":return document.body.clientHeight;case"id":return this.htmlElement.id;default:return ge(this,e)}},t.prototype.setProp=function(e,t,r){var n=this.htmlElement;function a(e,r){var a=t+"px";document.body.style[e]=a,r!==t&&(n.style[e]=a)}switch(e){case"clip-path":n.style.clipPath=t;break;case"frame-width":a("width",n.clientWidth);break;case"frame-height":a("height",n.clientHeight);break;default:ye(this,e,t)}},t.prototype.query=function(e,t){this.$scene.find(e).each(function(e,r){t(r,e)})},t}(Ae),Fe=function(e){function t(t){var r=e.call(this,t)||this;return r.vScene=t,r.isVirtual=!0,r}return __extends(t,e),t.prototype.getProp=function(e,t){return this.vScene.getProp(e,t)},t.prototype.setProp=function(e,t,r){this.vScene.setProp(e,t,r)},t.prototype.query=function(e,t){this.vScene.query(e,t)},t}(Ae);function Re(e,t,r,n,a){var i;!1===a||!a&&"string"!=typeof t?i=t:((!1===n||void 0===n&&!Pe(t))&&h("selector "+t+" must be virtual"),i=function(e,t){var r=t.substr(1),n=e._virtualAnimators.find(function(e){return e.selector===r});return n||(e.onGetVirtualElement||h("Story must have onGetVirtualElement to support virtual elements mapping"),e.onGetVirtualElement(r,e._args))}(e,t),n=!0),n=n||Ee(i),r.push(n?new Se(i):new Te(i))}function ke(e,t,r,a){if(a instanceof ot)return a._elementAdapters;if("function"==typeof a&&(a=a(e._args)),"string"==typeof a)Pe(a)?Re(e,a,t,!0,!0):r.query(a,function(r,n){Re(e,r,t,!1,!1)});else if("object"==typeof a&&void 0!==a.length){if(!a.length)return;a.forEach(function(r){Re(e,r,t)})}else f(n.UnknownType,{p:a.toString()});return t}function we(e,t){e.complete||t.waitMan.addWaitFunc(function(t,r,n){e.complete?n():e.addEventListener("load",function(){n()},{once:!0})},{})}function Ce(e,t,r){t.waitMan.addWaitFunc(function(n,a,i){if(void 0!==r){if(e.readyState<3)return void e.addEventListener("loadeddata",function(){Ce(e,t,r)},{once:!0});e.addEventListener("seeked",function(){i()},{once:!0}),e.currentTime=r}else i()},{})}function Ne(e,t,r){t.elAdapter.waitFor(t.waitFor,r,e)}var Me,Oe={"-webkit-":["background-clip"]},xe=/^(-webkit-|-moz-|-ie-|-ms-)(.*)$/;function Ve(t,r,n){var a=fe[t];if(n||void 0===a||"-"!==a[1][0]){var i=void 0!==a?a[0]:e.DPT_STYLE;fe[r]=[i,r],fe[t]=[i,r]}}e.TRS_SETUP=0,e.TRS_AT_OUT=1,e.TRS_AT_IN=2,e.DEFAULT_TRANSITION_DURATION="1s",function(e){e[e.slideLeft=0]="slideLeft",e[e.slideRight=1]="slideRight",e[e.slideTop=2]="slideTop",e[e.slideBottom=3]="slideBottom",e[e.dissolve=4]="dissolve"}(Me=e.StdTransitions||(e.StdTransitions={}));var Le,De={},Ue=function(){function t(){this._active=!1,this._transition={handler:""}}return t.prototype._set=function(t,r,n){this._active=!1,this._transition=t;var a=t.handler,i=t.duration;if(void 0===a)return!1;var o=m(i,n,e.DEFAULT_TRANSITION_DURATION,r);return 0!==o&&(this._params={bothVisible:!0,frameCount:o,leaveFrameCount:Math.round(o/2)},this._params.enterFrameCount=o-this._params.leaveFrameCount,"number"==typeof a&&(a=Me[a]),this._transitionFunc="string"==typeof a?De[a]:a,this._active=void 0!==this._transitionFunc,this._active)},t.prototype._setup=function(t,r,n,a){var i=this._params;this._firstOutTransitionFrame=n-i.leaveFrameCount,i.leaveAdapter=t,i.enterAdapter=r,i.state=e.TRS_SETUP,this._transitionFunc(i,a)},t.prototype._render=function(t,r,n,a){var i=this._params;if(n){var o=t-this._firstOutTransitionFrame;o>=0&&(i.state=e.TRS_AT_OUT,i.enterFrameI=void 0,i.leaveRealFrameI=t,i.frameI=o,i.bothVisible&&i.enterAdapter&&0===i.frameI&&i.enterAdapter.setProp("visible",!0,a),this._transitionFunc(i,a))}else t<=i.enterFrameCount&&(i.state=e.TRS_AT_IN,i.enterFrameI=t,i.leaveRealFrameI=void 0,i.frameI=t+i.leaveFrameCount,i.bothVisible&&(i.enterAdapter&&0===t&&i.leaveAdapter.setProp("visible",!0,a),t===i.enterFrameCount&&i.leaveAdapter.setProp("visible",!1,a)),this._transitionFunc(i,a))},t}();function Be(r,n,a,i,o){var s=r,u=r.leaveAdapter;if(r.state===e.TRS_SETUP)s.ref=parseInt(u.getProp(a,n)),s.length=parseInt(u.getProp(i,n));else{var c=t(r.frameI/r.frameCount*s.length),p=s.ref;p=o?p-c:p+c,r.leaveAdapter.setProp(a,p,n),r.enterAdapter&&(p=o?p+s.length:p-s.length,r.enterAdapter.setProp(a,p,n))}}De.slideLeft=function(e,t){Be(e,t,"left","width",!0)},De.slideRight=function(e,t){Be(e,t,"left","width",!1)},De.slideTop=function(e,t){Be(e,t,"top","height",!0)},De.slideBottom=function(e,t){Be(e,t,"top","height",!1)},De.dissolve=function(t,r){if(t.state!==e.TRS_SETUP){var n=1-t.frameI/t.frameCount;t.leaveAdapter.setProp("opacity",n,r),t.enterAdapter&&(n=1-n,t.enterAdapter.setProp("opacity",n,r))}},function(e){e[e.easings=0]="easings",e[e.oscillators=1]="oscillators",e[e.paths=2]="paths",e[e.transitions=3]="transitions",e[e.tasks=4]="tasks",e[e.flyovers=5]="flyovers",e[e.functions=6]="functions"}(Le=e.Functionalities||(e.Functionalities={}));var Xe,Ge=[q,q,ne,se,De,le,y],je=function(){function t(){this._plugins=[],this._locale="en"}return t.prototype.addPlugin=function(e){this._plugins.push(e)},t.prototype.addEasings=function(e){e.forEach(function(e){q[e[0]]=e[1]})},t.prototype.addOscillators=function(e){e.forEach(function(e){q[e[0]]=e[1]})},t.prototype.addPaths=function(e){e.forEach(function(e){ne[e[0]]=e[1]})},t.prototype.addTasks=function(e){e.forEach(function(e){se[e[0]]=e[1]})},t.prototype.addTransitions=function(e){e.forEach(function(e){De[e[0]]=e[1]})},t.prototype.addFlyovers=function(e){e.forEach(function(e){le[e[0]]=e[1]})},t.prototype.addFunctions=function(e){e.forEach(function(e){y[e[0]]=e[1]})},t.prototype.addLocalization=function(t){this._locale=t.locale,this._locale||h("The localization locale can not be empty"),t.charRanges&&t.charRanges.forEach(function(t){e.CharRanges.push(t)});var r=t.messages;r&&Object.keys(r).forEach(function(e){n[e]=r[e]}),t.functionalities&&t.functionalities.forEach(function(e){var t=e[0],r=e[1],n="string"==typeof t?Le[t]:t;if(void 0===n)throw"Unknown functionality "+t;var a=Ge[n];r.forEach(function(e){a[e.dst]=a[e.src]})})},t}();e.pluginManager=new je,se["scene-transition"]=function(t,r,a,i,o){switch(i){case e.TS_TELEPORT:var s=a.handler;return"number"==typeof s?s=Me[s]:d("function"==typeof s,n.NoCode),a.handler=s,e.TR_EXIT;case e.TS_INIT:return o.scene.transition={handler:a.handler,duration:a.duration},e.TR_EXIT}},se["add-stills"]=function(t,r,n,a,i){switch(a){case e.TS_INIT:return i.scene.addStills(n.duration),e.TR_EXIT}},se["add-flyover"]=function(t,r,n,a,i){switch(a){case e.TS_INIT:return i.story.addFlyover(n.handler,n.params),e.TR_EXIT}},se["add-vars"]=function(t,r,n,a,i){switch(a){case e.TS_INIT:var o=n.vars||{},s=!1!==n.overwrite,u=!0===n.allowExpr;return Object.keys(o).forEach(function(e){for(var t=e.split("."),r=i.vars,n=t.shift();t.length;)r[n]=r[n]||{},r=r[n],n=t.shift();if(s||void 0===r[n]){var a=o[e];u&&"string"==typeof a&&A(a)&&(a=B(a,i)),r[n]=a}}),e.TR_EXIT}},function(e){e[e.normal=0]="normal",e[e.reverse=1]="reverse",e[e.alternate=2]="alternate",e[e["alternate-reverse"]=3]="alternate-reverse"}(Xe=e.Directions||(e.Directions={}));var We=[[1,1],[-1,-1],[1,-1],[-1,1]];function He(e,t,r,n){return r[0]!==r[1]&&(e+1)%n==0?t:((t+=r[Math.floor((e+1)/n)%2])>=n?t-=n:t<0&&(t+=n),t)}function qe(e,t,r,n,a,i){var o;switch(t=t||{},typeof e){case"undefined":return;case"number":e=n(e);case"string":e.startsWith("==")&&(e=j(e.substr(1),i)),A(e)?(o=r,t._expression=e):o=a[e];break;case"function":o=e}return o||f("Unknown: "+e),{handler:e,func:o,params:t}}e.BP_FIRST_INSIDE=0,e.BP_INSIDE=1,e.BP_ALL=2,e.FS_PREPARE=0,e.FS_TELEPORT=1,e.FS_RUN=2,e.DEFAULT_DURATION="1f",e.DEFAULT_FADE_DURATION="400ms";var $e=function(){function t(){}return t.prototype.assignValues=function(t,r,n,a,i){var o=r._args;if(this.framesPerCycle=m(t.duration,o,n?n.framesPerCycle:e.DEFAULT_DURATION,0),this.itemDelay=function(e,t){return e.itemDelayDuration?{duration:m(e.itemDelayDuration,t,0,0,!1),grouping:e.itemDelayGrouping,disturbance:e.itemDelayDisturbance?m(e.itemDelayDisturbance,t,0,0,!1):0}:{duration:0}}(t,o),r._strictMode)(n&&!e.isPositiveNatural(this.framesPerCycle)||!n&&!e.isNotNegativeNatural(this.framesPerCycle))&&h(a+" has invalid duration frames: "+this.framesPerCycle);else if(this.framesPerCycle<0&&n&&!this.framesPerCycle)return r._logLevel>=e.LL_ERROR&&r.logMsg(a+" has invalid duration frames: "+this.framesPerCycle),!1;if(this.positionFrame=m(t.position,o,i,i),this.advance=t.advance,r._strictMode)e.isNotNegativeNatural(this.positionFrame)||h(a+" has invalid position: "+this.positionFrame);else if(this.positionFrame<0)return r.logMsg(a+" has invalid position: "+this.positionFrame),!1;return t.easing?this.easing=qe(t.easing,{},ee,Q,q,o):n&&(this.easing=n.easing),t.oscillator?this.oscillator=qe(t.oscillator.handler,t.oscillator.params,ee,te,q,o):n&&(this.oscillator=n.oscillator),t.path?this.path=qe(t.path.handler,t.path.params,ie,ae,ne,o):n&&(this.path=n.path),!0},t}();e._AbstractWorkAnimation=$e;var Qe=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.elAdapters=[],t.propInterpolators=[],t}return __extends(t,e),t.prototype.buildElements=function(e,t,r){this.elAdapters=ke(e,this.elAdapters,t,r.selector)},t}($e),Ye=function(e){function r(t){var r,n=e.call(this)||this;return n.realPropName=t.prop,n.propName=t.prop,n.animProp=t,n.iterationCount=Math.max(t.iterationCount||1,1),n.scaleDuration=n.iterationCount,n.dirPair=void 0===(r=t.direction)?We[Xe.normal]:("string"==typeof r&&(r=Xe[r]),(r<0||r>=We.length)&&h("Direction has an invalid value"),We[r]),n.bypassForwardMode=t.bypassForwardMode,n.bypassBackwardMode=t.bypassBackwardMode,n.roundFunc=p(t.roundFunc),n.waitFor=t.waitFor?t.waitFor.map(function(e){return e.prop=e.prop||n.propName,e}):void 0,n}return __extends(r,e),r.prototype.propAssignValues=function(e,r,n,a){if(!this.assignValues(e,r,n,this.realPropName,void 0!==n.nextPropStartFrame?n.nextPropStartFrame:n.positionFrame))return!1;var i=this.positionFrame+(this.itemDelay.duration?function(e,r){var n=e.disturbance;return n&&(r=r+2*Math.random()*n-n),Math.max(t((e.grouping?r%e.grouping:r)*e.duration),0)}(this.itemDelay,a):0);return this.startFrame=i,this.totalDuration=this.framesPerCycle*this.scaleDuration,this.endFrame=this.totalDuration+i,n.nextPropStartFrame=!0===this.advance?this.endFrame:void 0,!0},r}($e);function ze(e,t){e.forEach(function(e){e.tasks&&function(e,t,r){t.forEach(function(t){ue(t,e,!0,r)})}(e,e.tasks,t)})}e._WorkAnimationProp=Ye;function Ke(t,r,n){switch(n||e.BP_FIRST_INSIDE){case e.BP_FIRST_INSIDE:return!r;case e.BP_ALL:return!0;case e.BP_INSIDE:return!r&&!t}}e.PT_BOOLEAN=0,e.PT_NUMBER=1,e.PT_PIXEL=2,e.PT_STR=3,e.PT_VALUE_TEXT_LIST=4,e.PT_VALUE_TEXT_FUNC=5,e.PT_VALUE_TEXT_EXPR=6;var Je=/^-?[\d\.]+(?:px)?$/;function Ze(e,t){return l(e,void 0,0,t)}var et=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),a.prototype.attachSelector=function(t,r,a,i){var o=this,s=this.realPropName,u=r.actionRg;var c,p=void 0!==(c=o.animProp.valueStart)?Ze(c,i):-1!==r.linkIndex?r.actionRgList[r.linkIndex].endValue:t.getProp(s,i);"auto"===p&&(p="");var l=p,d=0,_=e.PT_NUMBER,m=this.animProp.valueText;if(m){switch(typeof m){case"string":A(m)||h("Invalid valueText"),_=e.PT_VALUE_TEXT_EXPR;break;case"function":_=e.PT_VALUE_TEXT_FUNC;break;case"object":_=e.PT_VALUE_TEXT_LIST,m.length||h("Invalid valueText");break;default:h("Invalid valueText")}d=P(l)?parseFloat(l):0}else switch(typeof p){case"undefined":break;case"boolean":_=e.PT_BOOLEAN,d=!0===p?1:0;break;case"number":d=p,u.propType===e.PT_PIXEL&&(_=e.PT_PIXEL);break;case"string":"true"===l||"false"===l?(_=e.PT_BOOLEAN,d="true"===l?1:0):0===l.search(Je)?l.endsWith("px")?(_=e.PT_PIXEL,d=parseFloat(l.substr(0,l.length-2))):(_=e.PT_NUMBER,d=parseFloat(l)):(_=e.PT_STR,d=P(l)?parseFloat(l):0)}var y,v=this.animProp.value;switch(_){case e.PT_BOOLEAN:y=v>.5?1:0;break;default:y=void 0!==v?function(e,t,r){if("string"==typeof(e=Ze(e,r))){if("+"===e[0])return t+parseFloat(e.substr(1));if("-"===e[0])return t-parseFloat(e.substr(1));var a=parseFloat(e);return isNaN(a)&&f(n.ValueTypeError,{p:e}),e}return e}(v,d,i):1}this.propType=_,this.numStartValue=d,this.numEndValue=y,this.variation=this.numEndValue-this.numStartValue,this.actRg=u,u.initialValue=d,u.waitFor=this.waitFor,u.propType=this.propType},a.prototype.interpolate=function(t,n,a){var i=n._args;S.v0=this.numStartValue,S.v1=this.numEndValue,S.vd=this.variation;var o=this.easing?this.easing.func(t,this.easing.params,i):t;S.vot=o;var s,u=(this.oscillator?this.oscillator.func(o,this.oscillator.params,i):o)*this.variation+this.numStartValue;this.curNumValue=u;var c=1;this.path&&(S.vpt=u,1===(c=(s=this.path.func(u,this.path.params,e.FS_RUN,i)).length)&&(u=s[0]));var p=u,l=this.animProp.valueFormat,h=this.propType;if(1===c){switch(p=this.roundFunc?this.roundFunc(p):p,h){case e.PT_BOOLEAN:p=p>.5?1:0;break;case e.PT_PIXEL:p=(this.roundFunc?u:Math.round(u)).toString()+"px";break;case e.PT_VALUE_TEXT_EXPR:S.t=p,p=B(this.animProp.valueText,i).toString();break;case e.PT_VALUE_TEXT_LIST:var f=this.animProp.valueText,d=f.length;p=f[Math.floor(d*Math.min(Math.max(0,p),.999))];break;case e.PT_VALUE_TEXT_FUNC:p=this.roundFunc?this.roundFunc(p):p,p=this.animProp.valueText(u,i)}p=l?r(l,p):p}else s=function(e,t){return t?e.map(function(e){return t(e)}):e}(s,this.roundFunc),p=l?r.apply(void 0,[l].concat(s)):s.toString();return p},a.prototype.toAction=function(e,t,r){return{realPropName:this.realPropName,value:e,actRg:this.actRg,numValue:this.curNumValue,toBypassForward:Ke(t,r,this.bypassForwardMode),toBypassBackward:Ke(r,t,this.bypassBackwardMode)}},a}(Ye);function tt(e,t,r,n,a){void 0===a&&(a=!1);var i,o=e.actRg,s=e.value,u=e.realPropName;if(i=s,a||t.setProp(u,i,n),o.waitFor&&o.waitFor.length)for(var c=0,p=o.waitFor;c<p.length;c++){var l=p[c];n.waitMan.addWaitFunc(Ne,{waitFor:l,elAdapter:t})}return e.numValue}var rt=function(){function t(t,r,n){this._active=!1,this.hasStory=!1,this._story=t,this._cfg=r,n?(e.pluginManager._plugins.forEach(function(e){e.teleportable||h("Plugin "+e.id+" doesn't supports teleporting")}),this._active=!0,r.version=e.VERSION,r.locale=e.pluginManager._locale,r.file=r.file||"__PROJDIR__/index.html",r.renderPos=0,r.renderCount=0,r.userAgent=window.navigator.userAgent,r.metadata={},r.plugins=e.pluginManager._plugins,r.animations=[]):this.hasStory=void 0!==r.html}return t.prototype.createSnapshot=function(){this._cfg.html=this._story.storyAdapter.getProp("html",this._story._args).split(/\n/),this._cfg.css=function(){for(var e=at(),t=window.document.styleSheets,r=[],n=0;n<t.length;n++){var a=t[n],i=a.href;if(!i.endsWith("normalize.css")&&!i.endsWith("abeamer.min.css"))for(var o=i.startsWith(e)?i.substr(e.length).replace(/\/[^/]*$/,"/"):"",s=a.cssRules,u=0;u<s.length;u++){var c=s[u];r.push({path:o,text:c.cssText})}}return r}()},Object.defineProperty(t.prototype,"active",{get:function(){return this._active},enumerable:!0,configurable:!0}),t.prototype._getStoryToTeleportAsConfig=function(){return this._cfg.renderPos=this._story.renderFramePos,this._cfg.renderCount=this._story.renderFrameCount,this._cfg.metadata=this._story.metadata,{config:{abeamer:this._cfg}}},t.prototype._rebuildStory=function(){var e=this._story;this._cfg.css&&function(e){for(var t=at(),r=window.document.styleSheets,n=r[r.length-1],a=n.cssRules.length,i=0;i<e.length;i++){var o=e[i],s=o.text.replace(/([\w\-]+)\s*:([^;]*;)/g,function(e,t,r){var n=function(e){var t=e.replace(xe,"$2"),r=fe[t];return r&&r[1]&&r[1]!==t?[t,r[1]]:[t]}(t);return n.map(function(e){return e+": "+r}).join(" ")}),u=it(t,o.path,s);n.insertRule(u,a++)}}(this._cfg.css),this._cfg.html&&(e.storyAdapter.setProp("html",this._cfg.html.join("\n").replace(/\<\s*script/gi,""),e._args),e.addDefaultScenes()),this._cfg.animations&&e.addStoryAnimations(this._cfg.animations),this._cfg.metadata&&nt(this._cfg.metadata,e.metadata)},t.prototype._addScene=function(){this._cfg.animations.push([])},t.prototype._addAnimations=function(e,t){this._cfg.animations[t].push(nt(e,[]))},t.prototype._fillFrameOpts=function(e){return e=e||{},this._active,e},t}();function nt(e,t){return Array.isArray(e)?e.forEach(function(e){switch(typeof e){case"function":f(n.NoCode);break;case"object":t.push(nt(e,Array.isArray(e)?[]:{}));break;default:t.push(e)}}):Object.keys(e).forEach(function(r){if("_"!==r[0]){var a=e[r];switch(typeof a){case"function":f(n.NoCode);break;case"object":t[r]=Array.isArray(a)?[]:{},nt(a,t[r]);break;default:t[r]=a}}}),t}function at(){var e=window.location;return e.origin+(e.pathname||"").replace(/\/[^/]*$/,"/")}function it(e,t,r){return t?r.replace(/url\("([^"]+)"\)/g,function(r,n){return n.startsWith("http")?r:'url("'+(e+t+n)+'")'}):t}var ot=function(){function t(e,t){this._elementAdapters=[],this._scene=e,this._selector=t,this._elementAdapters=e.getElementAdapters(t)}return t.prototype.getSelector=function(){return S.isTeleporting?this._selector:this},t.prototype.fadeIn=function(t){var r=this.getSelector();return this._scene.addSerialAnimations([[{selector:r,duration:"1f",props:[{prop:"visible",value:1}]}],[{selector:r,position:"-1f",duration:t||e.DEFAULT_FADE_DURATION,props:[{prop:"opacity",value:1}]}]]),this},t.prototype.fadeOut=function(t){var r=this.getSelector();return this._scene.addSerialAnimations([[{selector:r,duration:t||e.DEFAULT_FADE_DURATION,props:[{prop:"opacity",value:0}]}],[{selector:r,position:"-1f",duration:"1f",props:[{prop:"visible",value:0}]}]]),this},t.prototype.show=function(){return this._scene.addAnimations([{selector:this.getSelector(),duration:"1f",props:[{prop:"visible",value:1}]}]),this},t.prototype.hide=function(){return this._scene.addAnimations([{selector:this.getSelector(),duration:"1f",props:[{prop:"visible",value:0}]}]),this},t.prototype.text=function(e){return this._scene.addAnimations([{selector:this.getSelector(),duration:"1f",props:[{prop:"text",valueText:[e]}]}]),this},t}(),st=function(){function t(e,t,r){this._frameCount=0,this._storyFrameStart=0,this._storySceneIndex=-1,this._frameInNr=0,this._addAnimationCallCount=0,this._frames=[],this._renderFramePos=0,this._transitionInterpolator=new Ue,this._actionRgMaps=[],this._story=e,this._sceneAdpt=be(t)?new Fe(t):new Ie(t),r&&(this._prevScene=r,r._nextScene=this)}return Object.defineProperty(t.prototype,"transition",{get:function(){return this._transitionInterpolator._transition},set:function(e){this._transitionInterpolator._set(e,this._frameCount,this._story._args),this._story.isTeleporting&&!this._addAnimationCallCount&&this.addAnimations([{tasks:[{handler:"scene-transition",params:{handler:e.handler,duration:e.duration}}]}])},enumerable:!0,configurable:!0}),t.prototype._remove=function(){this._prevScene&&(this._prevScene._nextScene=this._nextScene),this._nextScene&&(this._nextScene._prevScene=this._prevScene)},Object.defineProperty(t.prototype,"frameInNr",{get:function(){return this._frameInNr},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"frameCount",{get:function(){return this._frameCount},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"storyFrameStart",{get:function(){return this._story._calcFrameCount(),this._storyFrameStart},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"storySceneIndex",{get:function(){return this._storySceneIndex},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return this._sceneAdpt.getProp("id",this._story._args)},enumerable:!0,configurable:!0}),t.prototype._containsFrame=function(e){return this._story._calcFrameCount(),this._internalContainsFrame(e)},t.prototype._internalContainsFrame=function(e){return e>=this._storyFrameStart&&e<this._storyFrameStart+this._frameCount},t.prototype._setStoryParams=function(e,t){return this._storyFrameStart=e,this._storySceneIndex=t,this._frameCount},t.prototype._gotoSceneFrame=function(e){(e<0||e>=this._frameCount)&&h("Position "+e+" is out of scope"),this._internalGotoFrame(e)},t.prototype._internalGotoFrame=function(e){if(e!==this._renderFramePos)for(var t=this._story.isVerbose,r=e>this._renderFramePos?1:-1;e!==this._renderFramePos;)this._internalRenderFrame(this._renderFramePos,r,t,!0)},t.prototype._show=function(){this._sceneAdpt.setProp("visible","true",this._story._args)},t.prototype._hide=function(){this._sceneAdpt.setProp("visible","false",this._story._args)},t.prototype._setupTransition=function(){this._transitionInterpolator._active&&this._transitionInterpolator._setup(this._sceneAdpt,this._nextScene?this._nextScene._sceneAdpt:void 0,this._frameCount,this._story._args)},t.prototype.addStills=function(e){this._story.isTeleporting&&!this._addAnimationCallCount&&this.addAnimations([{tasks:[{handler:"add-stills",params:{duration:e}}]}]);var t=m(e,this._story._args,0,0);if(t<=0)return this;var r=this._frameInNr+t;return r>this._frames.length&&(this._frames.length=r,this._frameCount=r),this._frameInNr=r,this},t.prototype._initInterpolators=function(t){var r=this,n=this._story,a=n._args,i=[];return t.forEach(function(t){if(!1!==t.enabled){var o=new Qe;o.buildElements(r._story,r._sceneAdpt,t),o.elAdapters.length?o.assignValues(t,n,void 0,o.elAdapters[0].getId(a),r._frameInNr)?t.props.forEach(function(e){o.propInterpolators.push(!1!==e.enabled?new et(e):void 0)}):o=void 0:r._story._logLevel>=e.LL_WARN&&r._story.logWarn("Selector "+t.selector+" is empty"),i.push(o)}else i.push(void 0)}),i},t.prototype.addAnimations=function(t){var r=this;if(!t.length)return this;var n=this._story,a=n._args,i=this._frameInNr,o=this._story._isVerbose,s=n._args.stage,u=!0;n._exceptIfRendering(),n._teleporter.active&&(ze(t,a),n._teleporter._addAnimations(t,this._storySceneIndex)),this._addAnimationCallCount++,a.stage=e.AS_ADD_ANIMATION;try{n.curScene!==this&&n._internalGotoScene(this);var c=[],p=[];t.forEach(function(t){var r,n=t.tasks;n&&function(t,r,n,a){var i=!0;return t.forEach(function(t){var o=ue(t,n,!1,a);switch(o.func(n,o,o.params,e.TS_INIT,a)){case e.TR_EXIT:return;case e.TR_DONE:i=!1;break;case e.TR_INTERACTIVE:i=!1,r.push(o)}}),i}(n,r=[],t,a)&&!t.props||(c.push(t),p.push(r))}),t=c;var l=this._initInterpolators(t),f=0;t.forEach(function(s,c){var d=l[c];if(d){var _=d.propInterpolators,m=d.elAdapters;S.elCount=m.length,f&&(d.positionFrame+=f),c===t.length-1&&(u=!1!==d.advance),m.forEach(function(t,u){S.elIndex=u;var l=p[c];l&&function(t,r,n,a){t.forEach(function(t){t.animeIndex=n,t.func(r,t,t.params,e.TS_ANIME_LOOP,a)})}(l,s,c,a),d.nextPropStartFrame=void 0,s.props.forEach(function(e,s){var c=_[s];if(c&&c.propAssignValues(e,n,d,u)){var p=c.startFrame,l=c.endFrame,m=c.totalDuration;l>r._frameCount&&(r._frames.length=l,r._frameCount=l),i=Math.max(i,l),d.advance&&(f=Math.max(f,l-r._frameInNr));var y=function(e,t,r,n,a,i){var o,s=t.getProp("uid",i),u=void 0!==s?parseInt(s):-1;u>=0?o=e[u]:(u=e.length,t.setProp("uid",u.toString(),i),o={},e.push(o));var c=o[r];c||(c=[],o[r]=c);var p={startFrame:n,endFrame:a};c.push(p);var l={actionRgMap:o,actionRgList:c,actionRg:p,linkIndex:c.length-2};if(l.linkIndex>=0){var f=c[l.linkIndex];p.propType=f.propType,f.endFrame>=n&&h("overlapping property animations is not supported."+f.endFrame+" must be higher than "+n)}return l}(r._actionRgMaps,t,c.realPropName,p,l-1,a);c.attachSelector(t,y,o,a);for(var v,g,T=1===c.dirPair[0]?0:c.framesPerCycle-1,S=0;S<m;S++){var E=c.framesPerCycle>1?T/(c.framesPerCycle-1):1;v=c.interpolate(E,n,o),g=c.toAction(v,0===S,S===m-1),T=He(S,T,c.dirPair,c.framesPerCycle),r._setActionOnFrames(p,t,c,g,v),p++}var P=tt(g,t,0,a,!0);y.actionRg.endValue=P}})})}})}catch(e){throw e}finally{u&&(this._frameInNr=i),this._addAnimationCallCount--,this._addAnimationCallCount||(a.stage=s),n._setFrameCountChanged()}return this},t.prototype._setActionOnFrames=function(e,t,r,n,a){function i(){return{elementAdpt:t,actions:[n]}}var o;if(t._clearComputerData(),void 0===this._frames[e])this._frames[e]={elActions:[i()],uniqueElementAdpt:new Set([t])};else{(o=this._frames[e]).uniqueElementAdpt.add(t);var s=o.elActions.find(function(e){return e.elementAdpt===t});if(s){var u=s.actions,c=u.find(function(e){return e.realPropName===r.propName});c?c.value=a:u.push(n)}else o.elActions.push(i())}},t.prototype.addSerialAnimations=function(e){var t=this;return e.forEach(function(e){return t.addAnimations(e)}),this},t.prototype._internalRenderFrame=function(e,t,r,n){var a=this._story._args;if(!n){this._transitionInterpolator._active&&this._transitionInterpolator._render(e,this._frameCount,!0,this._story._args);var i=this._prevScene;i&&i._transitionInterpolator._active&&i._transitionInterpolator._render(e,this._frameCount,!1,this._story._args)}var o=this._frames[e];if(o){for(var s=o.elActions.length,u=0;u<s;u++)for(var c=o.elActions[u],p=c.elementAdpt,l=c.actions.length,h=0;h<l;h++){var f=c.actions[h];if(n)if(t>0?f.toBypassForward:f.toBypassBackward)continue;tt(f,p,0,a)}o.uniqueElementAdpt.forEach(function(e){e.frameRendered&&e.frameRendered(a)}),this._renderFramePos+=t}else this._renderFramePos+=t},t.prototype.getElementAdapters=function(e){return ke(this._story,[],this._sceneAdpt,e)},t.prototype.getPEls=function(e){return new ot(this,e)},t.prototype.pElsShow=function(e){return this.getPEls(e).show()},t.prototype.pElsHide=function(e){return this.getPEls(e).hide()},t.prototype.pElsFadeIn=function(e,t){return this.getPEls(e).fadeIn(t)},t.prototype.pElsFadeOut=function(e,t){return this.getPEls(e).fadeOut(t)},t}(),ut=function(){function e(){this.funcs=[],this.pos=0}return e.prototype.addWaitFunc=function(e,t){this.funcs.push({func:e,params:t})},e}(),ct=function(){function t(t,r){var a=this;this._isServerReady=!1,this._width=0,this._height=0,this._frameCount=0,this._frameCountChanged=!1,this._renderFramePos=0,this._renderDir=1,this._renderFrameEnd=0,this._renderFrameCount=0,this._renderStage=0,this._renderPlaySpeed=0,this._isRendering=!1,this._scenes=[],this._curScene=void 0,this._wkFlyovers=[],this._queueRenders=[],this._metadata={},this._args={renderNr:0,stage:e.AS_UNKNOWN,vars:S},this.defaultUnit=i.f,this.hasServer=!1,this._strictMode=!1,this._logLevel=0,this.toExitOnRenderFinished=!0,this._virtualAnimators=[],this._virtualAnimatorMap={},this.bestPlaySpeed=function(){return Math.abs(1e3/a.fps)};var s=window.location.search||"",c=this._args,p=this;function l(t,r,a){var i=r||p.storyAdapter.getProp(a,c);return s&&s.replace(new RegExp(t+"(\\d+)"),function(e,t){var r=parseInt(t);return i=r||i,""}),d(!e.isPositiveNatural(i),n.MustNatPositive,{p:a}),p.storyAdapter.setProp(a,i,c),i}this.logLevel=r.logLevel||e.LL_SILENT,s&&s.replace(new RegExp(o.LOG_LEVEL_SUFFIX+"(\\d+)"),function(e,t){return a.logLevel=parseInt(t),""}),function(t){if(!e.browser.vendorPrefix){var r=-1!==navigator.userAgent.search(/Trident/);e.browser.isMsIE=r;for(var n=window.getComputedStyle(document.body),a=(n||[]).length,i=!1,o=function(t){var a=n[t],o=a.match(xe);if(o){if(!i){var s=o[1];e.browser.vendorPrefix=s,i=!0;var u=Oe[s];u&&u.forEach(function(e){Ve(e,s+e,!r)})}var c=o[2];e.browser.prefixedProps.push(c),Ve(c,a,!r)}},s=0;s<a;s++)o(s)}}(),this._waitMan=new ut,c.waitMan=this._waitMan,this.storyAdapter=r.storyAdapter||new Ie(".abeamer-story"),t.fps=t.fps||this.storyAdapter.getProp("fps",c),d(!e.isPositiveNatural(t.fps),n.MustNatPositive,{p:"fps"}),S.fps=t.fps,this._width=t.width=l(o.WIDTH_SUFFIX,t.width,"frame-width"),S.frameWidth=t.width,this._height=t.height=l(o.HEIGHT_SUFFIX,t.height,"frame-height"),S.frameHeight=t.height,this.storyAdapter.setProp("clip-path","polygon(0 0, 0 "+t.height+"px, "+t.width+"px "+t.height+"px, "+t.width+"px 0px)",c),c.story=this,this.fps=t.fps,this._isTeleporting=r.toTeleport||!1,s&&(s.replace(new RegExp(o.TELEPORT_SUFFIX+"(\\w+)"),function(e,t){return a._isTeleporting="true"===t,""}),s.replace(new RegExp(o.SERVER_SUFFIX+"(\\w+)"),function(e,t){return a.hasServer=!0,a.storyAdapter.setProp("class","has-server",c),a.serverName=t,a.serverFeatures=u(a.serverName),""}),s.replace(new RegExp(o.RENDER_VAR_SUFFIX+"([^&]+)","g"),function(e,t){var r=(t=decodeURIComponent(t)).match(/^([^=]+)=(.*)$/)||["","",""],n=r[1],a=r[2];if(!n)throw"var "+t+" requires the key field";return n=n.replace(/-(\w)/g,function(e,t){return t.toUpperCase()}),c.vars[n]=a,""})),c.hasServer=this.hasServer,c.isTeleporting=this._isTeleporting,c.vars.isTeleporting=c.isTeleporting,this._teleporter=new rt(this,t,this._isTeleporting),this._isTeleporting&&!1!==r.toStartTeleporting&&this.startTeleporting(),this._teleporter.hasStory?this._teleporter._rebuildStory():r.dontAddDefaultScenes||this.addDefaultScenes()}return Object.defineProperty(t.prototype,"metadata",{get:function(){return this._metadata},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"width",{get:function(){return this._width},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"height",{get:function(){return this._height},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"frameCount",{get:function(){return this._calcFrameCount(),this._frameCount},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"renderDir",{get:function(){return this._renderDir},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"renderFrameEnd",{get:function(){return this._renderFrameEnd},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"renderFramePos",{get:function(){return this._renderFramePos},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"renderFrameCount",{get:function(){return this._renderFrameCount},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isRendering",{get:function(){return this._isRendering},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isTeleporting",{get:function(){return this._isTeleporting},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"args",{get:function(){return this._args},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"strictMode",{get:function(){return this._strictMode},set:function(e){this._strictMode=e,this._args.isStrict=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"logLevel",{get:function(){return this._logLevel},set:function(t){this._logLevel=t,this._isVerbose=t>=e.LL_VERBOSE,this._args.isVerbose=this._isVerbose},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isVerbose",{get:function(){return this._isVerbose},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scenes",{get:function(){return this._scenes},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"curScene",{get:function(){return this._curScene},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"virtualAnimators",{get:function(){return console.log("virtualAnimators has been deprecated, use addVirtualAnimator"),this._virtualAnimators},enumerable:!0,configurable:!0}),t.prototype.addVirtualAnimator=function(e){var t=e.selector;t||f(n.NoEmptySelector),this._virtualAnimatorMap[t]&&h("The selector must be unique"),this._virtualAnimators.push(e),this._virtualAnimatorMap[t]=e},t.prototype.removeVirtualAnimator=function(e){var t=this._virtualAnimators.indexOf(e);-1!==t&&(this._virtualAnimators.splice(t,1),delete this._virtualAnimatorMap[e.selector])},t.prototype.addDefaultScenes=function(){var e=this;$(".abeamer-scene").each(function(t,r){e.addScene($(r))}),this._scenes.length&&this.gotoScene(this._scenes[0])},t.prototype.addScene=function(e){var t=new st(this,e,this._scenes.length?this._scenes[this._scenes.length-1]:void 0);return this._scenes.push(t),this._setFrameCountChanged(),this._teleporter.active&&this._teleporter._addScene(),t},t.prototype.removeScene=function(e){this._exceptIfRendering(),this._curScene===e&&(e._hide(),this._curScene=void 0),e._remove(),this._scenes.splice(e.storySceneIndex,1)},t.prototype.clear=function(){this._exceptIfRendering(),this.rewind(),this._internalGotoScene(void 0),this.scenes.length=0,this._renderFramePos=0,this._frameCount=0},t.prototype.addStoryAnimations=function(e){var t=this;e.forEach(function(e,r){t._scenes[r].addSerialAnimations(e)})},t.prototype.addStoryAnimationsBySceneId=function(e){var t={};this._scenes.forEach(function(e){t[e.id]=e}),Object.keys(e).forEach(function(r){var n=t[r];n&&n.addSerialAnimations(e[r])})},t.prototype.addFlyover=function(t,r){var a=function(t,r,a,i){var o;switch(typeof t){case"string":o=le[t];break;case"function":o=t,d(a,n.NoCode)}o||f(n.UnknownOf,{type:n.flyover,p:t});var s={func:o,name:t,params:r||{}};return a&&s.func(s,s.params,e.TS_TELEPORT,i),s}(t,r,!1,this._args);this._isTeleporting&&this._args.stage!==e.AS_ADD_ANIMATION&&this._scenes.length?this._scenes[0].addAnimations([{tasks:[{handler:"add-flyover",params:{handler:a.name,params:a.params}}]}]):(a.func(a,a.params,e.TS_INIT,this._args),this._wkFlyovers.push(a))},t.prototype.gotoScene=function(e){e!==this._curScene&&(this._exceptIfRendering(),this._calcFrameCount(),this._internalGotoScene(e))},t.prototype._internalGotoScene=function(e){var t=this._curScene;t&&t._hide(),this._curScene=e,e&&e._show(),this._args.scene=e},t.prototype.findSceneByName=function(e){return this._scenes.find(function(t){return t.name===e})},t.prototype._setFrameCountChanged=function(){this._frameCountChanged=!0},t.prototype._calcFrameCount=function(){if(this._frameCountChanged){var e=0;this._scenes.forEach(function(t,r){e+=t._setStoryParams(e,r)}),this._frameCountChanged=!1,this._frameCount=e}},t.prototype.rewind=function(){this.gotoFrame(0)},t.prototype.gotoFrame=function(e){this._exceptIfRendering(),this._calcFrameCount(),(e<0||e>=this._frameCount)&&f(n.OutOfScope,{p:n.pos}),this._internalGotoFrame(e)},t.prototype._internalGotoFrame=function(e){var t=this._curScene;t&&t._internalContainsFrame(e)||(t=this._scenes.find(function(t){return t._internalContainsFrame(e)}),this._internalGotoScene(t)),t._internalGotoFrame(e-t.storyFrameStart)},t.prototype._setupTransitions=function(){this._scenes.forEach(function(e){e._setupTransition()})},t.prototype.getStoryToTeleport=function(e,t){var r=this.getStoryToTeleportAsConfig(e);return void 0!==r?JSON.stringify(r,void 0,t?2:void 0):""},t.prototype.getStoryToTeleportAsConfig=function(e){if(!this._isTeleporting)throw"getStoryToTeleport requires to be in teleporting mode";if(this._calcRenderFrameOptions(e))return this._teleporter._getStoryToTeleportAsConfig()},t.prototype.teleport=function(e,t){this.hasServer||console.warn("To teleport it requires the render server agent to be running"),this._sendCmd(o.MSG_TELEPORT,this.getStoryToTeleport(e,t))},t.prototype.startTeleporting=function(){this._isTeleporting&&this._teleporter.createSnapshot()},t.prototype._exceptIfRendering=function(){if(this._isRendering)throw"Render is still running"},t.prototype._getSceneByHandler=function(t){switch(typeof t){case"object":return t;case"string":var r=this.findSceneByName(t);return d(!r,n.Unknown,{p:t}),r;case"number":var a=t;return this._strictMode&&d(e.isNotNegativeNatural(a),n.MustNatNotNegative,{p:a}),(a<0||a>=this._scenes.length)&&f(n.OutOfScope,{p:n.pos}),this._scenes[a]}},t.prototype._calcRenderFrameOptions=function(e){e=e||{},this._calcFrameCount();var t=m(e.renderPos,this._args,0,0),r=m(e.renderCount,this._args,this._frameCount,this._frameCount);if(void 0!==e.startScene){var n=this._getSceneByHandler(e.startScene);t+=n.storyFrameStart,void 0===e.renderCount&&(r-=n.storyFrameStart)}if(void 0!==e.endScene){var a=this._getSceneByHandler(e.endScene);void 0===e.renderCount&&(r=a.storyFrameStart+a.frameCount-t)}if(!r)return!1;var i=r>0?1:-1;-1===i&&h("Reverse render isn't supported yet");var o=r>0?t+r-1:t+r;if(r=Math.abs(r),t<0||t>=this._frameCount)throw"Render Pos is out of scope";if(o<-1||o>this._frameCount)throw"Render Count is out of scope";return this._renderFramePos=t,this._renderDir=i,this._renderFrameEnd=o,this._renderFrameCount=r,!0},t.prototype.render=function(e,t){return this.hasServer&&this._isTeleporting?(this.teleport(t,!0),void this.exit()):this._isRendering?((t=t||{}).playSpeedMs=e,void this._queueRenders.push(t)):void this._internalRender(e,t)},t.prototype._internalRender=function(t,r){this._args.stage=e.AS_RENDERING,this._isRendering=!0,this._calcRenderFrameOptions(this._teleporter._fillFrameOpts(r))?(this._renderStage=0,this._waitMan.funcs=[],this._waitMan.pos=0,this._renderPlaySpeed=!this.hasServer&&void 0!==t&&t>0?t:0,this._setupTransitions(),this.storyAdapter.setProp("visible",!0,this._args),this.hasServer?this._sendCmd(o.MSG_READY):this._renderLoop()):this.finishRender()},t.prototype.finishRender=function(){if(this._isRendering){if(this._isRendering=!1,this._renderTimer&&(window.clearTimeout(this._renderTimer),this._renderTimer=void 0),this._queueRenders.length){var t=this._queueRenders[0];return this._queueRenders.splice(0,1),void this._internalRender(t.playSpeedMs,t)}this._args.stage=e.AS_UNKNOWN,this._sendCmd(o.MSG_RENDER_FINISHED),this.toExitOnRenderFinished&&this.exit()}},t.prototype._renderLoop=function(){for(var t=this,r=this._renderStage,n=this._waitMan;;){if(!this._isRendering)return;if(r&&n.funcs.length>n.pos){this._renderStage=r;var a=n.funcs[n.pos];return n.pos++,n.funcs.length===n.pos&&(n.pos=0,n.funcs=[]),void a.func(this._args,a.params,function(){t._renderLoop()})}switch(r){case 0:r++,this._renderTimeStamp=new Date;break;case 1:r+=2,this._internalGotoFrame(this._renderFramePos);break;case 3:r++,this._wkFlyovers.forEach(function(r){r.func(r,r.params,e.TS_ANIME_LOOP,t._args)});break;case 4:r++,this.onBeforeRenderFrame&&this.onBeforeRenderFrame(this._args);break;case 5:r++,this._curScene._internalRenderFrame(this._renderFramePos-this._curScene.storyFrameStart,this._renderDir,this._isVerbose,!1);break;case 6:this.hasServer?r++:(r+=2,this.onAfterRenderFrame&&this.onAfterRenderFrame(this._args)),this._renderStage=r;var i=new Date-this._renderTimeStamp,s=Math.max(this._renderPlaySpeed-Math.floor(i),1);return void(this._renderTimer=window.setTimeout(function(){t.hasServer?t._sendCmd(o.MSG_RENDER):t._renderLoop()},s));case 7:r++,this.onAfterRenderFrame&&this.onAfterRenderFrame(this._args);break;case 8:if(r=0,this._renderFramePos===this._renderFrameEnd)return this._renderStage=-1,void this.finishRender();this._renderFramePos+=this._renderDir,this.onNextFrame&&this.onNextFrame(this._args)}}},t.prototype._sendCmd=function(e,t){console.log(o.MESSAGE_PREFIX+e+(t?o.CMD_VALUE_SEP+t:""))},t.prototype.exit=function(){this._sendCmd(o.MSG_EXIT)},t.prototype.logFrmt=function(t,r,n){var a=t+":"+r.map(function(e){return e[0]+"=_["+e[1]+"]_"}).join(" ");switch(n){case e.LT_WARN:this.logWarn(a);break;case e.LT_ERROR:this.logError(a);break;default:this.logMsg(a)}},t.prototype.logMsg=function(e){this.hasServer&&this.serverFeatures.hasLogging?this._sendCmd(o.MSG_LOG_MSG,e):console.log(e)},t.prototype.logWarn=function(e){this.hasServer&&this.serverFeatures.hasLogging?this._sendCmd(o.MSG_LOG_WARN,e):console.warn(e)},t.prototype.logError=function(e){this.hasServer&&this.serverFeatures.hasLogging?this._sendCmd(o.MSG_LOG_ERROR,e):console.error(e)},t.prototype._internalGetServerMsg=function(e,t){switch(e){case o.MSG_SERVER_READY:this._isServerReady=!0,this.logMsg("Received Server Ready"),this._sendCmd(o.MSG_SET_FPS,this.fps.toString()),this._sendCmd(o.MSG_SET_FRAME_COUNT,this._frameCount.toString()),this.onServerReady&&this.onServerReady(this._args),this._renderLoop();break;case o.MSG_RENDER_DONE:this._renderLoop()}},t.prototype.getElementAdapters=function(e){return ke(this,[],this.storyAdapter,e)},t}();e._Story=ct,e.createStory=function(e,t){return _abeamer=new ct({fps:e},t||{})},e.createStoryFromConfig=function(e,t,r,n){$.get(e,function(a){var i;e.endsWith(".json")?i=a:(i={},a.split(/\n/).forEach(function(e){return e.replace(/^\s*[\$@]abeamer-([\w+\-]+)\s*:\s*"?([^\n]+)"?\s*;\s*$/,function(e,t,r){return i[t]=r,""})}),i={config:{abeamer:i}});var o=i.config;if(o){var s=o.abeamer;s&&(s.fps=s.fps||r,_abeamer=new ct(s,n||{}),t(_abeamer))}})}}(ABeamer||(ABeamer={}));