"use strict";
// ------------------------------------------------------------------------
// Copyright (c) 2018-2024 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License.
// ------------------------------------------------------------------------

var ABeamer,__extends=this&&this.__extends||function(){var t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,i){t.__proto__=i}||function(t,i){for(var r in i)i.hasOwnProperty(r)&&(t[r]=i[r])};return function(i,r){function a(){this.constructor=i}t(i,r),i.prototype=null===r?Object.create(r):(a.prototype=r.prototype,new a)}}();!function(t){var i,r,a,e,s;!function(t){t[t.pie=0]="pie",t[t.bar=1]="bar",t[t.area=2]="area",t[t.line=3]="line",t[t.marker=4]="marker",t[t.mixed=5]="mixed"}(i=t.ChartTypes||(t.ChartTypes={})),function(t){t[t.horizontal=0]="horizontal",t[t.vertical=1]="vertical"}(r=t.ChartCaptionOrientation||(t.ChartCaptionOrientation={})),function(t){t[t.top=0]="top",t[t.bottom=1]="bottom",t[t.left=2]="left",t[t.right=3]="right"}(a=t.ChartCaptionPosition||(t.ChartCaptionPosition={})),function(t){t[t.left=0]="left",t[t.center=1]="center",t[t.right=2]="right"}(e=t.ChartCaptionAlignment||(t.ChartCaptionAlignment={})),function(t){t[t.circle=0]="circle",t[t.square=1]="square",t[t.diamond=2]="diamond"}(s=t.ChartPointShape||(t.ChartPointShape={})),t.pluginManager.addPlugin({id:"abeamer.chart-tasks",uuid:"73631f28-df71-4b4d-88e1-c99a858e0fd3",author:"Alexandre Bento Freire",email:"abeamer@a-bentofreire.com",jsUrls:["plugins/chart-tasks/chart-tasks.js"],teleportable:!0});var n=t.getVars().chart={labelsX:{fontFamily:"sans-serif",fontColor:"black",fontSize:12,alignment:e.center,position:a.bottom,orientation:r.horizontal,marginBefore:0,marginAfter:0},labelsY:{fontFamily:"sans-serif",fontColor:"black",fontSize:12,alignment:e.right,position:a.left,orientation:r.horizontal,marginBefore:0,marginAfter:5,tickCount:6},legend:{fontFamily:"sans-serif",fontColor:"black",fontSize:12,alignment:e.left,position:a.right,orientation:r.horizontal,marginBefore:0,marginAfter:5,mark:{width:10,height:3,spacing:4}},title:{fontFamily:"sans-serif",fontColor:"black",fontSize:14,alignment:e.center,position:a.top,orientation:r.horizontal,marginBefore:0,marginAfter:0},fillColors:"#ffecad",strokeColors:"#101010",strokeWidth:1,markers:{shape:s.square,size:5,color:"black"},barWidth:0,pointMaxHeight:100,pointDistance:0,seriesSpacing:3,nrPoints:10};function o(t,i){return t.forEach(function(t){t.forEach(function(t){i=Math.max(i,t)})}),i}var h=function(t){function i(){var i=null!==t&&t.apply(this,arguments)||this;return i.charts=[],i}return __extends(i,t),i.prototype.animateProps=function(){var t=this;this.charts.forEach(function(i){i._drawChart(t.params)})},i}(t.SimpleVirtualAnimator);function l(t,i){i.font=t.fontSize+"px "+t.fontFamily,i.fillStyle=t.fontColor,i.textBaseline="bottom"}function p(t){switch(typeof t){case"undefined":return{};case"string":return{captions:t};default:return t}}function c(t,i,r,a){if(t.alignment===e.left)return 0;var s=i.measureText(r);switch(t.alignment){case e.center:return(a-s.width)/2;case e.right:return a-s.width}return 0}var f=function(){function i(t){this.args=t,this.title={},this.legend={},this.overflow=0,this.graphX0=0,this.graphY1=0}return i.prototype._drawChart=function(t){this._drawLegend()},i.prototype._fillArrayArrayParam=function(t,i,r){var a=[];void 0===t&&(t=i);var e=Array.isArray(t);return!e&&r&&"string"==typeof t&&(t=r[t]),this.data.forEach(function(i,s){var n=[];if(e){var o=t[s],h=Array.isArray(o);!h&&r&&"string"==typeof o&&(o=r[o]),n=h?i.map(function(t,i){var a=o[i];return r&&"string"==typeof a&&(a=r[a]),a}):i.map(function(t){return o})}else n=i.map(function(i){return t});a.push(n)}),a},i.prototype._initChart=function(t){this.fillColors=this._fillArrayArrayParam(t.fillColors,n.fillColors),this.strokeColors=this._fillArrayArrayParam(t.strokeColors,n.strokeColors),this.strokeWidth=this._fillArrayArrayParam(t.strokeWidth,n.strokeWidth),this.overflow=o(this.strokeWidth,this.overflow),this.graphX1=this.chartWidth,this.graphY0=this.chartHeight,this._initTitle(t),this._initLegend(t)},i.prototype._init=function(i,r,a){this.canvas=i.getProp("element",this.args),this.canvas||t.throwErr("Didn't find the "+i.getId()),this.context=this.canvas.getContext("2d"),this.chartWidth=this.canvas.width,this.chartHeight=this.canvas.height,this.chartType=r,this.animator=a,this.props=a?a.props:{}},i.prototype._initData=function(i){var r,a=this,e=-Number.MIN_VALUE,s=Number.MAX_VALUE,o=0;this.data=i.map(function(i,e){var s;if(Array.isArray(i))s=i;else{s=[];var o=i,h=o.startValue||0,l=o.step||1,p=o.nrPoints||r||n.nrPoints;a.args.vars.n=p;for(var c=0;c<p;c++){a.args.vars.v=c*l+h;var f=t.calcExpr(o.expr,a.args);s.push("number"==typeof f?f:parseFloat(f))}}return e?s.length!==r&&t.throwErr("Every Series must have the same number of points"):r=s.length,s}),this.data.forEach(function(t){t.forEach(function(t){e=Math.max(e,t),s=Math.min(s,t),o+=t})}),this.min=s,this.max=e,this.sum=o,this.avg=(e-s)/2,this.nrPoints=r},i.prototype._initCaptions=function(i,s,n,o){var h,p=this,c={fontColor:t.ExprOrStrToStr(n.fontColor||o.fontColor,i.fontColor,this.args),fontFamily:t.ExprOrStrToStr(n.fontFamily||o.fontFamily,i.fontFamily,this.args),fontSize:t.ExprOrNumToNum(n.fontSize||o.fontSize,i.fontSize,this.args),alignment:t.parseEnum(n.alignment,e,i.alignment),position:t.parseEnum(n.position,a,i.position),orientation:t.parseEnum(n.orientation,r,i.orientation),marginBefore:t.ExprOrNumToNum(n.marginBefore,i.marginBefore,this.args),marginAfter:t.ExprOrNumToNum(n.marginAfter,i.marginAfter,this.args)};if(l(c,this.context),c.position===a.top||c.position===a.bottom){var f=s.join(" "),g=this.context.measureText(f);c.width=g.width}else c.width=0,s.forEach(function(t){c.width=Math.max(c.width,p.context.measureText(t).width)});switch(c.height=1.2*c.fontSize,c.position){case a.top:c.y=this.graphY1+c.height+c.marginBefore,h=c.height+c.marginBefore+c.marginAfter,this.graphY1+=h;break;case a.left:c.x=this.graphX0+c.marginBefore,h=c.width+c.marginBefore+c.marginAfter,this.graphY0=Math.min(this.graphY0,this.chartHeight-c.height/2),this.graphX0+=h;break;case a.bottom:c.y=this.graphY0-c.marginAfter,h=c.height+c.marginBefore+c.marginAfter,this.graphY0-=h;break;case a.right:h=c.width+c.marginBefore+c.marginAfter,c.x=this.graphX1+c.marginBefore-h,this.graphY0=Math.min(this.graphY0,this.chartHeight-c.height/2),this.graphX1-=h}return c},i.prototype._initTitle=function(i){var r=i.title||{};"string"==typeof r&&(r={caption:r}),r.caption&&(this.title=this._initCaptions(n.title,[r.caption],r,r),this.title.caption=t.ExprOrStrToStr(r.caption,"",this.args))},i.prototype._initLegend=function(i){var r=p(i.legend),e=r.captions;if(e){this.legend=this._initCaptions(n.legend,e,r,r),this.legend.captions=e;var s=n.legend.mark,o=r.mark||{};this.legend.mark={width:t.ExprOrNumToNum(o.width,s.width,this.args),height:t.ExprOrNumToNum(o.height,s.height,this.args),spacing:t.ExprOrNumToNum(o.spacing,s.spacing,this.args)};var h=this.legend.mark.width+this.legend.mark.spacing;switch(this.legend.position){case a.left:this.legend.x+=h,this.graphX0+=h;break;case a.right:this.graphX1-=h}}},i.prototype._getLegendColor=function(t,i){return this.fillColors[t][i]},i.prototype._drawLegend=function(){var t=this,i=this.legend;if(i.captions){var r=this.context,a=i.mark,e=i.x,s=i.height,n=i.height,o=1===this.data.length;i.captions.forEach(function(h,p){var f=s+p*n;l(i,r);var g=c(i,r,h,i.width);r.fillText(h,e+g,f),r.fillStyle=o?t._getLegendColor(0,p):t._getLegendColor(p,0),r.fillRect(e+g-a.width-a.spacing,f-(n+a.height)/2,a.width,a.height)})}},i}();var g=function(r){function a(){var t=null!==r&&r.apply(this,arguments)||this;return t.xDrawPoints=[],t}return __extends(a,r),a.prototype._calcCaptions=function(i,r,a,e){var s=i;if(!s||!Array.isArray(s)){for(var n=t.isExpr(s),o=[],h=(e-a)/(r-1),l=0;l<r;l++){var p=a+l*h;if(n){this.args.vars.v=p;var c=t.calcExpr(s,this.args);o.push(c.toString())}else o.push(p.toString())}i=o}return i},a.prototype._initLabels=function(t){var i,r=p(t.labelsX),a=p(t.labelsY);if((i=r.captions)&&(i=this._calcCaptions(i,this.nrPoints,0,this.nrPoints-1),this.labelsX=this._initCaptions(n.labelsX,i,r,a),this.labelsX.captions=i),i=a.captions,0!==a.tickCount||i){i=this._calcCaptions(i,a.tickCount||n.labelsY.tickCount,this.minValue,this.maxValue),this.labelsY=this._initCaptions(n.labelsY,i,a,r),this.labelsY.captions=i;var e=this.labelsY.height/2;this.graphY1=Math.max(this.graphY1,e)}},a.prototype._getLegendColor=function(t,r){return this.chartTypes[t]!==i.line?this.fillColors[t][r]:this.strokeColors[t][r]},a.prototype._initLine=function(i){return{visible:void 0===i.visible||i.visible,color:t.ExprOrStrToStr(i.color,"#7c7c7c",this.args),width:t.ExprOrNumToNum(i.width,1,this.args)}},a.prototype._initMarkers=function(t){var r={};this.hasMarkers=void 0!==t.markers||-1!==this.chartTypes.findIndex(function(t){return t===i.marker});var a=t.markers||{};this.hasMarkers&&(r.visible=this._fillArrayArrayParam(a.visible,this.chartType===i.marker),r.shape=this._fillArrayArrayParam(a.shape,n.markers.shape,s),r.size=this._fillArrayArrayParam(a.size,n.markers.size),r.color=this._fillArrayArrayParam(a.color,n.markers.color),this.overflow=o(r.size,this.overflow)),this.markers=r},a.prototype._drawMarkers=function(t){var i=this.markers,r=this.context;this.data.forEach(function(a,e){for(var n=0;n<a.length;n++)if(i.visible[e][n]){r.fillStyle=i.color[e][n];var o=i.size[e][n]/2,h=t[e][n],l=h[0],p=h[1];switch(i.shape[e][n]){case s.circle:r.beginPath(),r.arc(l,p,o,0,2*Math.PI),r.fill();break;case s.diamond:r.beginPath(),r.moveTo(l-o,p),r.lineTo(l,p-o),r.lineTo(l+o,p),r.lineTo(l,p+o),r.fill();break;case s.square:r.fillRect(l-o,p-o,o,o)}}})},a.prototype._drawLine=function(t,i,r,a,e){var s=this.context;s.beginPath(),s.strokeStyle=t.color,s.lineWidth=t.width,s.moveTo(i,r),s.lineTo(a,e),s.stroke()},a.prototype._computeBestValues=function(){this.bestMaxValue=function(t){var i=Math.abs(t),r=t<0,a=Math.log10(i),e=Math.floor(a),s=Math.pow(10,e),n=i%s;if(Math.abs(n)>1e-5){var o=i-n;return r?-o+s:o+s}return t}(this.max)},a.prototype._computeDrawPoints=function(r){var a=this;this.pointMaxHeight=t.ExprOrNumToNum(r.pointMaxHeight,n.pointMaxHeight,this.args);var e=this.graphX0+this.overflow,s=this.graphX1-this.overflow-e,o=this.nrPoints,h=s/o,l=t.ExprOrNumToNum(r.pointDistance,n.pointDistance,this.args);l=l||h;var p=e,c=this.chartTypes.reduce(function(t,r){return t+(r===i.bar?1:0)});if(0===c)for(var f=function(t){var i=p+l/2;g.xDrawPoints.push({x:p,xLabel:p,xLabelWidth:l,series:g.data.map(function(){return{x:i,w:l}})}),p+=l},g=this,u=0;u<o;u++)f();else{var m=t.ExprOrNumToNum(r.barWidth,n.barWidth,this.args),d=t.ExprOrNumToNum(r.seriesSpacing,n.seriesSpacing,this.args);m||(m=l/c-d);var v=m*c+d*(c-1),y=function(t){var r=p,e=p+l/2;x.xDrawPoints.push({x:p,xLabel:p,xLabelWidth:v,series:x.data.map(function(t,s){if(a.chartTypes[s]===i.bar){var n=r;return r+=m+d,{x:n,w:m}}return{x:e,w:l}})}),p+=l},x=this;for(u=0;u<o;u++)y()}this.x1=p},a.prototype._initChart=function(a){var e=this;this.chartTypes=this.data.map(function(r,s){return e.chartType!==i.mixed?e.chartType:!a.chartTypes||a.chartTypes.length<=s?i.bar:t.parseEnum(a.chartTypes[s],i,i.bar)}),this.xAxis=this._initLine(a.xAxis||{}),this.yAxis=this._initLine(a.yAxis||{}),this.y0Line=this._initLine(a.y0Line||{}),this._computeBestValues(),this.maxValue=t.ExprOrNumToNum(a.maxValue,this.bestMaxValue,this.args),this.minValue=t.ExprOrNumToNum(a.minValue,Math.min(this.min,0),this.args),this.avgValue=this.avg,r.prototype._initChart.call(this,a),this.negativeFillColors=a.negativeFillColors?this._fillArrayArrayParam(a.negativeFillColors,"white"):this.fillColors,this._initMarkers(a),this._initLabels(a),this._computeDrawPoints(a),this.props["point-height"]=t.ExprOrNumToNum(a.pointHeightStart,1,this.args),this.props.deviation=t.ExprOrNumToNum(a.deviationStart,1,this.args),this.props.sweep=t.ExprOrNumToNum(a.sweepStart,1,this.args)},a.prototype._drawChart=function(t){var a=this,e=this.props["point-height"],s=this.props.deviation,n=this.props.sweep,o=this.chartWidth,h=this.chartHeight,p=this.context,f=this.graphX0,g=this.graphY0,u=g-this.graphY1-1,m=this.maxValue,d=this.minValue,v=m-d,y=m*d<0,x=y?0:d>=0?d:m,b=g-u*((x-d)/v),_=this.data,w=this.nrPoints,C=n>=1?w:Math.max(Math.min(Math.floor(w*n)+1,w),0);p.clearRect(0,0,o,h),r.prototype._drawChart.call(this,t);var k=b,T=[];_.forEach(function(t,r){for(var o,h,l=[],c=[],f=a.chartTypes[r],g=0;g<C;g++){p.lineWidth=a.strokeWidth[r][g],p.strokeStyle=a.strokeColors[r][g];var m=t[g];Math.abs(s-1)>1e-6&&(m=a.avgValue-(a.avgValue-m)*s),p.fillStyle=m>=0?a.fillColors[r][g]:a.negativeFillColors[r][g];var d=a.xDrawPoints[g].series[r],y=-u*((m-x)/v*e),b=y+k,_=d.x,A=_,E=g===C-1&&n<1;if(E){var P=(n-g/w)/(1/w);A=(A-o)*P+o,b=(b-h)*P+h}var S=A,N=b;switch(f){case i.bar:var M=d.w;if(E){var L=a.xDrawPoints[g],Y=L.xLabel+L.xLabelWidth*n;M=Y<_?0:Math.min(_+M,Y)-_}M>0&&(p.fillRect(_,k,M,y),p.strokeRect(_,k,M,y)),S=_+M/2;break;case i.line:g&&(p.beginPath(),p.moveTo(o,h),p.lineTo(A,b),p.stroke())}o=A,h=b,l.push([A,b]),c.push([S,N])}f===i.area&&(p.beginPath(),p.moveTo(l[0][0],k),l.forEach(function(t){p.lineTo(t[0],t[1])}),p.lineTo(l[l.length-1][0],k),p.lineTo(l[0][0],k),p.fill(),p.stroke()),T.push(c)}),p.lineWidth=1,this.hasMarkers&&this._drawMarkers(T);var A,E=this.title.caption;if(this.title.caption){l(this.title,p);var P=c(this.title,p,E,this.x1-this.graphX0);p.fillText(E,this.graphX0+P,this.title.y)}if(this.labelsX){l(this.labelsX,p),A=this.labelsX.captions;for(var S=0;S<A.length;S++){var N=this.xDrawPoints[S].xLabel,M=A[S],L=c(this.labelsX,p,M,this.xDrawPoints[S].xLabelWidth);p.fillText(M,N+L,this.labelsX.y)}}if(this.labelsY){l(this.labelsY,p),A=this.labelsY.captions;var Y=this.labelsY.height/2,O=u/(A.length-1);for(S=0;S<A.length;S++){var X=g-O*S;M=this.labelsY.captions[S],L=c(this.labelsY,p,M,this.labelsY.width);p.fillText(M,this.labelsY.x+L,X+Y)}}y&&this.y0Line.visible&&this._drawLine(this.y0Line,f,b,this.x1,b),this.xAxis.visible&&this._drawLine(this.xAxis,f,g,this.x1,g),this.yAxis.visible&&this._drawLine(this.yAxis,f,g,f,g-u)},a}(f),u=function(i){function r(){return null!==i&&i.apply(this,arguments)||this}return __extends(r,i),r.prototype._initChart=function(r){i.prototype._initChart.call(this,r),this.props.angle=t.ExprOrNumToNum(r.angleStart,0,this.args),this.props.dispersion=t.ExprOrNumToNum(r.dispersionStart,1,this.args)},r.prototype._drawChart=function(t){var r=this,a=this.props.angle,e=this.props.dispersion,s=!1!==t.isClockwise,n=this.overflow,o=this.graphX0+n,h=this.graphY1+n,l=Math.min(this.graphX1-o-n,this.graphY0-h-n)/2,p=this.context;p.clearRect(0,0,this.chartWidth,this.chartHeight),i.prototype._drawChart.call(this,t),this.data.forEach(function(t,i){for(var n=0;n<2;n++)for(var c=a,f=0;f<t.length;f++){p.lineWidth=r.strokeWidth[i][f],p.strokeStyle=r.strokeColors[i][f],p.fillStyle=r.fillColors[i][f];var g=t[f]/r.sum*Math.PI*2*e;s||(g=-g),g+=c,p.beginPath(),p.moveTo(o+l,h+l),p.arc(o+l,h+l,l,c,g),p.closePath(),0===n?p.fill():p.stroke(),c=g}})},r}(f);t.pluginManager.addTasks([["chart",function(r,a,e,s,n){switch(s){case t.TS_INIT:var o=e.chartType;"string"==typeof o&&(o=i[o]);var l,p=e.data;p.length||t.throwErr("Series have empty data"),e.animeSelector&&((l=new h).selector=e.animeSelector,l.params=e,n.story.addVirtualAnimator(l));var c=n.scene.getElementAdapters(r.selector);n.vars.elCount=c.length,c.forEach(function(r,a){var s;switch(n.vars.elIndex=a,o){case i.pie:s=new u(n);break;case i.marker:case i.bar:case i.line:case i.area:case i.mixed:s=new g(n);break;default:t.throwI8n(t.Msgs.UnknownType,{p:e.chartType})}s._init(r,o,l),s._initData(p),s._initChart(e),s._drawChart(e),l&&l.charts.push(s)})}return t.TR_EXIT}]])}(ABeamer||(ABeamer={}));