"use strict";
// ------------------------------------------------------------------------
// Copyright (c) 2018-2024 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License.
// ------------------------------------------------------------------------

var __extends=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();Object.defineProperty(exports,"__esModule",{value:!0});var HttpServerEx,sysFs=require("fs"),http_server_js_1=require("./http-server.js");!function(e){var t=function(e){function t(t,r,n,i,o,s){void 0===r&&(r=!1),void 0===n&&(n=""),void 0===i&&(i=!1),void 0===o&&(o=!1),void 0===s&&(s=!1);var l=e.call(this,t)||this;return l.isVerbose=r,l.exitFile=n,l.allowDirListing=i,l.markdownCompiler=o?require("marked"):void 0,l.highlightJs=s?require("highlight.js"):void 0,l}return __extends(t,e),t.prototype.markdownToHtml=function(e){var t=this;return this.markdownCompiler.setOptions({renderer:new this.markdownCompiler.Renderer,highlight:function(e){return t.highlightJs?t.highlightJs.highlightAuto(e).value:e},pedantic:!1,gfm:!0,tables:!0,breaks:!1,sanitize:!1,smartLists:!0,smartypants:!1,xhtml:!1}),"<html>\n<head>\n"+(this.highlightJs?'\n    <link rel="stylesheet" href="/node_modules/highlight.js/styles/github.css">\n    <link rel="stylesheet" href="/node_modules/font-awesome/css/font-awesome.css">\n    <style>\n    body {\n      font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Helvetica,Arial,\n        sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol";\n        color: #24292e;\n        background-color: white;\n    }\n    pre {\n      background-color: #1b1f230d;\n      padding: 0.2em 0.4em;\n    }\n    #__page {\n       max-width: 980px;\n       padding: 45px;\n       border: 1px solid #ddd;\n       border-bottom-right-radius: 3px;\n       border-bottom-left-radius: 3px;\n       margin-left: 20px;\n    }\n    code {\n      background-color: #1b1f230d;\n      padding: 0.2em 0.4em;\n    }\n    pre code {\n      background-color: transparent;\n      padding: 0;\n    }\n\n    </style>\n    <script src="/node_modules/highlight.js/lib/highlight.js"><\/script>\n    <script>hljs.initHighlightingOnLoad();<\/script>\n':"")+"</head>\n<body>\n<div id=__page>"+this.markdownCompiler(e)+"</div></body>\n</html>"},t.prototype.onBeforeServe=function(e,t){return e.url.length>1024||-1!==e.url.indexOf("..")||e.url.match(/\.[\w+\-]+\.(json|txt|ini)$/)?(t.statusCode=403,t.end("forbidden url"),!1):(this.isVerbose&&console.log(e.method+" "+e.url),!this.exitFile||-1===e.url.indexOf(this.exitFile)||(this.isVerbose&&console.log("Closing the server"),this.httpServer.close(),!1))},t.prototype.onAfterServe=function(e){if(this.markdownCompiler&&".md"===e.ext){var t=sysFs.readFileSync(e.path,{encoding:"utf-8"});return e.res.setHeader("Content-type","text/html"),e.res.end(this.markdownToHtml(t)),!1}return!0},t.prototype.handleDirectory=function(t){return this.allowDirListing&&"?dir"===t.search?(sysFs.readdir(t.path,function(e,r){var n=t.path+(t.path.endsWith("/")?"":"/"),i=r.map(function(e){var t=""+n+e;return{file:e,fileName:t,url:t.substr(1),isDir:sysFs.statSync(t).isDirectory()}});i.sort(function(e,t){return e.isDir===t.isDir?e.file.localeCompare(t.file):e.isDir?-1:1}),"./"!==n&&i.unshift({file:"..",fileName:n+"..",url:n.substr(1)+"../",isDir:!0});var o='<html>\n<head>\n<style>\nbody {\n    font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Helvetica,Arial,\n      sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol";\n      color: #24292e;\n      background-color: white;\n}\n</style>\n          </head><body>\n'+i.map(function(e){var t=e.isDir,r=[];return t&&http_server_js_1.HttpServer.DEFAULT_FILES.forEach(function(t){var n=e.fileName+"/"+t;sysFs.existsSync(n)&&r.push('&nbsp;(<a href="'+e.url+"/"+t+'">'+t+"</a>)")}),t?'<div>[<a href="'+e.url+'?dir">'+e.file+"</a>]"+r.join("")+"</div>":'<div><a href="'+e.url+'">'+e.file+"</a></div>"}).join("\n")+"\n</body>\n</html>";t.res.setHeader("Content-type","text/html"),t.res.end(o)}),!1):e.prototype.handleDirectory.call(this,t)},t}(http_server_js_1.HttpServer.Server);e.ServerEx=t}(HttpServerEx=exports.HttpServerEx||(exports.HttpServerEx={}));